module solve_eb
    use iso_c_binding
    implicit none

    integer, parameter:: dp=(kind(0.d0))

    real(c_double), dimension(:), parameter :: h_list(15) = [0., 50., 100., 200., 300., 400., 500., 600.,&
    700., 800., 900., 1000., 5000., 10000., 20000.]

    real(c_double), dimension(:), parameter :: a_list(15) = [340.29, 340.10, 339.91, 339.53, 339.14, 338.76, 338.38,&
    337.98, 337.6, 337.21, 336.82, 336.43, 320.54, 299.53, 295.07]

    real(c_double), parameter :: g = 9.81, rho_0 = 1.2066, pi = 3.1415926536883458

    contains

    real(c_double) function linear_interp(x, x_array, y_array, n_nodes) result(y)
        real(c_double), intent(in):: x, x_array(n_nodes), y_array(n_nodes)
        integer(c_int), intent(in):: n_nodes

        integer:: i

        if(x <= x_array(1)) then
            y = y_array(1)
        elseif(x >= x_array(n_nodes)) then
            y = y_array(n_nodes)
        else
            do i=2, n_nodes-1
                if(x >= x_array(i) .and. x <= x_array(i+1)) then
                    y = y_array(i) + ((y_array(i+1) - y_array(i))*(x - x_array(i)))/(x_array(i+1) - x_array(i))
                end if
            end do
        end if


    end function linear_interp

    real(c_double) function get_cx(v, y, cx_list, mach_list, n_machs) result(cx)
        real(c_double), intent(in):: v, y, cx_list(n_machs), mach_list(n_machs)
        integer(c_int), intent(in):: n_machs
        
        real(c_double) :: a, m
        integer(c_int) :: i

        a = linear_interp(y, h_list, a_list, 15)
        
        m = v/a

        cx = linear_interp(m, mach_list, cx_list, n_machs)

    end function get_cx

    subroutine ext_bal_rs(dy, y, d, q, cx_list, mach_list, n_machs)
        real(c_double), intent(out) :: dy(4)
        real(c_double), intent(in) :: y(4), d, q, cx_list(n_machs), mach_list(n_machs)
        integer(c_int), intent(in):: n_machs

        real(c_double) :: cx, hy, jt

        hy = rho_0 * ((20000.0 - y(2)) / (20000.0 + y(2)))

        cx = get_cx(y(3), y(2), cx_list, mach_list, n_machs)

        jt = -0.5 * cx * hy * y(3)**2

        dy(1) = y(3) * cos(y(4))

        dy(2) = y(3) * sin(y(4))

        dy(3) = jt * 0.25*(pi * d ** 2)/q - g * sin(y(4))

        dy(4) = -g * cos(y(4))/y(3)
    end subroutine ext_bal_rs

    subroutine count_eb(y0, d, q, cx_list, mach_list, n_machs, max_distance, tstep, tmax) bind(c, name="count_eb")

        real(c_double), intent(inout) :: y0(4), cx_list(n_machs), mach_list(n_machs)
        real(c_double), intent(in), value :: d, q, max_distance, tstep, tmax
        integer(c_int), intent(in), value:: n_machs

        real(c_double) :: y1(4), dy(4, 4), t0

        t0 = 0.0

        do while(y0(2) >= 0.0 .and. y0(1) < max_distance)
            y1 = y0
            call ext_bal_rs(dy(:, 1), y1, d, q, cx_list, mach_list, n_machs)
            call ext_bal_rs(dy(:, 2), y1 + 0.5*tstep*dy(:, 1), d, q, cx_list, mach_list, n_machs)
            call ext_bal_rs(dy(:, 3), y1 + 0.5*tstep*dy(:, 2), d, q, cx_list, mach_list, n_machs)
            call ext_bal_rs(dy(:, 4), y1 + tstep*dy(:, 3), d, q, cx_list, mach_list, n_machs)

            t0 = t0 + tstep
            y0 = y1 + tstep*(dy(:, 1) + 2*dy(:, 2) + 2*dy(:, 3) + dy(:, 4))/6
        end do

        if (y0(2) < 0.0) then
            y0 = y1 + (0.0 - y1(2)) * ((y0-y1)/(y0(2)-y1(2)))
        end if

        if (y0(1) > max_distance) then
            y0 = y1 + (max_distance - y1(1)) * ((y0-y1)/(y0(1)-y1(1)))
        end if

    end subroutine count_eb

    subroutine dense_count_eb(y_array, d, q, cx_list, mach_list, n_machs, max_distance, tstep, tmax, n_tsteps) bind(c, name="dense_count_eb")

        real(c_double), intent(inout) :: y_array(4, n_tsteps), cx_list(n_machs), mach_list(n_machs)
        integer(c_int), intent(inout) :: n_tsteps
        integer(c_int), intent(in), value:: n_machs

        real(c_double), intent(in), value :: d, q, max_distance, tstep, tmax

        real(c_double) :: y1(4), dy(4, 4), t0

        integer(c_int) :: i

        t0 = 0.0

        do i=2, n_tsteps
            call ext_bal_rs(dy(:, 1), y_array(:, i-1), d, q, cx_list, mach_list, n_machs)
            call ext_bal_rs(dy(:, 2), y_array(:, i-1) + 0.5*tstep*dy(:, 1), d, q, cx_list, mach_list, n_machs)
            call ext_bal_rs(dy(:, 3), y_array(:, i-1) + 0.5*tstep*dy(:, 2), d, q, cx_list, mach_list, n_machs)
            call ext_bal_rs(dy(:, 4), y_array(:, i-1) + tstep*dy(:, 3), d, q, cx_list, mach_list, n_machs)

            t0 = t0 + tstep
            y_array(:, i) = y_array(:, i-1) + tstep*(dy(:, 1) + 2*dy(:, 2) + 2*dy(:, 3) + dy(:, 4))/6

            if(y_array(2, i) < 0.0 .or. y_array(1, i) > max_distance) then
                n_tsteps = i
                exit
            end if

            if(t0 > tmax) then
                n_tsteps = i
                return
            end if
        end do

        if (y_array(2, n_tsteps) < 0.0) then
            y_array(:, n_tsteps) = y_array(:, n_tsteps-1) + (0.0 - y_array(2, n_tsteps-1)) * ((y_array(:, n_tsteps)-y_array(:, n_tsteps-1))/(y_array(2, n_tsteps)-y_array(2, n_tsteps-1)))
        end if

        if (y_array(1, n_tsteps) > max_distance) then
            y_array(:, n_tsteps) = y_array(:, n_tsteps-1) + (max_distance - y_array(1, n_tsteps-1)) * ((y_array(:, n_tsteps)-y_array(:, n_tsteps-1))/(y_array(1, n_tsteps)-y_array(1, n_tsteps-1)))
        end if

    end subroutine dense_count_eb

end module solve_eb

program test_mcdrag
    use mcdrag
    implicit none

    type(shell):: my_shell
    real(dp):: res, am

    integer(c_int):: i, n_tsteps=200, n_machs = 30

    real(dp):: m(30), cd0_array(30), cdh_array(30), cdbt_array(30), cdb_array(30), cdrb_array(30), cdsf_array(30)

    do i=1, 30
        m(i) = i * 0.2_dp
    end do

    call set_shell_geo(my_shell, 152.4_dp, 5.65_dp, 3.01_dp, 0.58_dp, 0.09_dp, 1.02_dp, 0.848_dp, 0.5_dp, 2)

    call get_aerodynamics(m, n_machs, my_shell, cd0_array, cdh_array, cdbt_array, cdb_array, cdrb_array, cdsf_array)

    print *, cd0_array, m

end program test_mcdrag

      SUBROUTINE SIMP
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BETA
      COMMON/CVP/CXT(240),CNT(240),CMT(240),CPV(21),JA,JB,KF
      COMMON/DIS2/SUM1,SUM2,SUM3,SUM4,SUM5,SUM6
      SUM1=0.D0
      SUM2=0.D0
      SUM3=0.D0
      DO 2 I=JA,JB
      F1=CXT(I)
      G=CNT(I)
      G1=CMT(I)
      IF(I.EQ.JA) GO TO 4
      H=(RB(I)-RB(I-1))/2.D0
      H1=(XB(I)-XB(I-1))/2.D0
      SUM1=SUM1+H*(SF1+F1)
      SUM2=SUM2+H1*(SG+G)
      SUM3=SUM3+H1*(SG1+G1)
    4 SF1=F1
      SG=G
      SG1=G1
  2   END DO
      RETURN
      END

module preproc
    use ibstructs
    implicit none

    private t_acc

    real(dp), parameter :: ig_f=240.0e3_dp, ig_t=2427.0_dp, ig_theta = 0.22_dp
    contains
        subroutine compute_igniter(ign, ibp, powds)
            ! Расчет воспламенителя
            type(igniter), intent(out) :: ign
            type(ibproblem), intent(in) :: ibp
            type(powder), dimension(:), intent(in) :: powds

            real(dp) :: igniter_mass
            real(dp) :: ro_om_sum
            
            integer :: i, n_powd

            ro_om_sum = 0.0_dp
            n_powd = size(powds)

            if (ibp%ig_mass > 0.0_dp) then
                igniter_mass = ibp%ig_mass
            else
                do i = 1, n_powd
                    ro_om_sum = ro_om_sum + powds(i)%om/powds(i)%ro
                end do
                igniter_mass = ibp%pv*(ibp%artsystem%w0 - ro_om_sum)/ig_f
            end if

            ign%fs = igniter_mass*ig_f
            ign%num = ign%fs/ig_t
            ign%denum = ign%num/ig_theta

        end subroutine compute_igniter

        subroutine temp_account(charge, t)
            type(powder), dimension(:), intent(inout) :: charge
            real(dp), intent(in) :: t

            integer :: i, n_powd
            
            n_powd = size(charge)

            do i = 1, n_powd
               call t_acc(charge(i), t)
            end do
        end subroutine

        subroutine t_acc(powd, t)
            type(powder), intent(inout) :: powd
            real(dp), intent(in) :: t

            powd%jk = powd%jk*(1 - powd%gamma_jk*(t - 15.0_dp))
            powd%f_powd = powd%f_powd*(1 + powd%gamma_f*(t - 15.0_dp))

        end subroutine t_acc
end module preproc

module mcdrag
use iso_c_binding

implicit none
integer, parameter:: dp=(kind(0.d0))

type, bind(c) :: shell
    real(c_double):: d
    real(c_double):: L
    real(c_double):: h_l
    real(c_double):: b_l
    real(c_double):: m_d
    real(c_double):: b_d
    real(c_double):: bs_d
    real(c_double):: hs_p
    real(c_double):: t_r
    integer(c_int):: bl_code
end type shell

    contains

        subroutine set_shell_geo(ashell, d, L, h_l, b_l, m_d, b_d, bs_d, hs_p, bl_code) bind(c, name='set_shell_geo')
            type(shell), intent(out):: ashell
            real(c_double), intent(in), value:: d, L, h_l, b_l, m_d, b_d, bs_d, hs_p
            integer(c_int), intent(in), value:: bl_code

            ashell%d = d
            ashell%L = L
            ashell%h_l = h_l
            ashell%b_l = b_l
            ashell%m_d = m_d
            ashell%b_d = b_d
            ashell%bs_d = bs_d
            ashell%hs_p = hs_p

            ashell%t_r = (1.0_dp - m_d) / h_l

            ashell%bl_code = bl_code


        end subroutine set_shell_geo

        pure real(c_double) function cdsf(M, ashell) bind(c, name='cdsf')
            real(c_double), intent(in), value:: M
            type(shell), intent(in):: ashell

            real(c_double):: Re, r3, cfl, cft, d5, sw_nose, sw_cyl, sw_total, c9, c10

            Re = 23296.3_dp * M * ashell%L * ashell%d
            r3 = 0.4343_dp * log(Re)
            cfl = (1.328_dp / sqrt(Re)) / (1.0_dp + 0.12_dp * M ** 2) ** 0.12_dp
            cft = (0.455 / r3 ** 2.58) / (1.0_dp + 0.21 * M ** 2) ** 0.32_dp
            d5 = 1.0_dp + ((0.333_dp + (0.02_dp / ashell%h_l ** 2)) * ashell%hs_p)

            sw_nose = 1.5708_dp * ashell%h_l * d5 * (1.0_dp + (1.0_dp / (8.0_dp * ashell%h_l ** 2)))
            sw_cyl = 3.1415 * (ashell%L - ashell%h_l)
            sw_total = sw_nose + sw_cyl

            select case (ashell%bl_code)
                case (0)
                    c9 = 1.2732_dp * sw_total * cfl
                    c10 = c9

                case (1)
                    c9 = 1.2732_dp * sw_total * cfl
                    c10 = 1.2732_dp * sw_total * cft

                case (2)
                    c9 = 1.2732_dp * sw_total * cft
                    c10 = c9
            end select

            cdsf = (c9 * sw_nose + c10 * sw_cyl) / sw_total
        end function cdsf

        pure real(c_double) function cdrb(M, ashell) bind(c, name='cdrb')
            real(c_double), intent(in), value:: M
            type(shell), intent(in):: ashell

            if (M < 0.95_dp) then
                cdrb = (M ** 12.5) * (ashell%b_d - 1.0_dp)
            else
                cdrb = (0.21_dp + 0.28_dp / M ** 2) * (ashell%b_d - 1.0_dp)
            end if

        end function cdrb

        pure real(c_double) function cdb(M, ashell) bind(c, name='cdb')
            real(c_double), intent(in), value:: M
            type(shell), intent(in):: ashell

            real(c_double):: p1, p2, p4

            if (M < 1.0_dp) then
                p2 = 1.0_dp / (1.0_dp + 0.1875_dp * M ** 2 + 0.0531_dp * M ** 4)
            else
                p2 = 1.0_dp / (1.0_dp + 0.2477_dp * M ** 2 + 0.0345_dp * M ** 4)
            end if

            p4 = (1.0_dp + 9.000001E-02 * (1.0_dp - exp(ashell%h_l - ashell%L)) * M ** 2)
            p4 = p4 * (1.0_dp + 0.25_dp * (1.0_dp - ashell%bs_d)* M ** 2)

            p1 = p2 * p4

            if (p1 < 0.0_dp) then
                p1 = 0.0_dp
            end if

            cdb = (1.4286 * (1.0_dp - p1) * ashell%bs_d ** 2) / M ** 2
        end function cdb

        pure real(c_double) function cdbt(M, ashell) bind(c, name='cdbt')
            real(c_double), intent(in), value:: M
            type(shell), intent(in):: ashell

            real(c_double):: t2, t3, c15, e1, b4, b2, b, b3, a12, a11, e2, x3, a1, r5, e3, a2

            if (ashell%b_l <= 0.0_dp .or. M <= 0.85_dp) then 
                cdbt = 0.0_dp
                return
            end if

            t2  = (1.0_dp - ashell%bs_d) / (2 * ashell%b_l)

            if (M <= 1.0_dp) then
                t3 = 2.0_dp * t2 ** 2 + t2 ** 3
                c15 = (M ** 2 - 1.0_dp) / (2.4_dp * M ** 2)
                e1 = exp(-2.0_dp * ashell%b_l)
                b4 = 1.0_dp - e1 + 2 * t2 * ((e1 * (ashell%b_l + 0.5_dp)) - 0.5_dp)

                cdbt = 2.0_dp * t3 * b4 * (1.0_dp / (0.564_dp + 1250.0_dp * c15 ** 2))

            elseif (M <= 1.1_dp) then
                t3 = 2.0_dp * t2 ** 2 + t2 ** 3
                c15 = (M ** 2 - 1.0_dp) / (2.4_dp * M ** 2)
                e1 = exp(-2.0_dp * ashell%b_l)
                b4 = 1.0_dp - e1 + 2 * t2 * ((e1 * (ashell%b_l + 0.5_dp)) - 0.5_dp)

                cdbt = 2.0_dp * t3 * b4 * (1.774_dp - 9.3_dp * c15)

            else
                b2 = M ** 2 - 1.0_dp
                b = sqrt(b2)
                b3 = 0.85_dp / b
                a12 = (5 * ashell%t_r) / (6 * b)
                a12 = a12 + (0.5_dp * ashell%t_r) ** 2
                a12 = a12 - (0.734_dp / M ** 2) * ((ashell%t_r * M) ** 1.6_dp)

                a11 = (1.0_dp - 0.6_dp * ashell%hs_p / M) * a12

                e2 = exp((ashell%L - ashell%h_l - ashell%b_l) * (-1.1952_dp / M))
                x3 = ((2.4_dp * M ** 4 - 4 * b2) * (t2 ** 2)) / (2 * b2 ** 2)
                a1 = a11 * e2 - x3 + 2 * t2 / b
                r5 = 1 / b3
                e3 = exp(-b3 * ashell%b_l)
                a2 = 1 - e3 + (2 * t2 * (e3 * (ashell%b_l + r5) - r5))

                cdbt = 4 * a1 * t2 * a2 * r5
            end if

        end function cdbt

        pure real(c_double) function cdh(M, ashell) bind(c, name='cdh')
            real(c_double), intent(in), value:: M
            type(shell), intent(in):: ashell

            real(c_double):: p5, mc, b2, b, s4, z, r_4, c11, c12, c13, c14, c15, c16, c17, c18

            if (M < 1.0_dp) then
                p5 = (1.0_dp + 0.2_dp * M ** 2) ** 3.5
            else
                p5 = ((1.2_dp * M ** 2) ** 3.5_dp) * (6.0_dp / (7.0_dp * M ** 2 - 1.0_dp)) ** 2.5_dp
            end if

            c15 = (M ** 2 - 1.0_dp) / (2.4_dp * M ** 2)
            c16 = (1.122 * (p5 - 1.0_dp) * ashell%m_d ** 2) / M ** 2

            if (M <= 0.91) then
                c18 = 0.0_dp
            elseif (M >= 1.41) then
                c18 = 0.85_dp * c16
            else
                c18 = (0.254_dp + 2.88_dp * c15) * c16
            end if

            if (M <= 1.0_dp) then
                mc = 1.0_dp / sqrt(1.0_dp + 0.552_dp * (ashell%t_r ** 0.8_dp))

                if (M < mc) then
                    c17 = 0.0_dp
                else
                    c17 = 0.368_dp * (ashell%t_r ** 1.8_dp) + 1.6_dp * ashell%t_r * C15
                end if
                
                cdh = c17 + c18
            end if

            if (M > 1.0_dp) then
                b2 = M ** 2 - 1.0_dp
                b = sqrt(b2)
                s4 = 1.0_dp + 0.368_dp * (ashell%t_r ** 1.85_dp)

                if (M >= S4) then
                    z = b
                else
                    z = sqrt(s4 ** 2 - 1.0_dp)
                end if

                r_4 = 1.0_dp / z ** 2
                c11 = 0.7156_dp - 0.5313_dp * ashell%hs_p + 0.595_dp * ashell%hs_p ** 2
                c12 = 0.0796_dp + 0.0779_dp * ashell%hs_p
                c13 = 01.587_dp + 0.049_dp * ashell%hs_p
                c14 = 0.1122_dp + 0.1658_dp * ashell%hs_p

                c17 = (c11 - c12 * (ashell%t_r ** 2)) * r_4 * ((ashell%t_r * z) ** (c13 + c14 * ashell%t_r))

                cdh = c17 + c18
            end if

        end function cdh

        pure real(c_double) function cd0(M, ashell) bind(c, name='cd0')
            real(c_double), intent(in), value:: M
            type(shell), intent(in):: ashell

            cd0 = cdh(M, ashell) + cdbt(M, ashell) + cdb(M, ashell) + cdrb(M, ashell) + cdsf(M, ashell)
        end function cd0

        subroutine get_aerodynamics_(M, ashell, cd0_, cdh_, cdbt_, cdb_, cdrb_, cdsf_)
            real(c_double), intent(in):: M
            type(shell), intent(in):: ashell

            real(c_double), intent(out):: cd0_, cdh_, cdbt_, cdb_, cdrb_, cdsf_

            real(c_double):: cd0_1, cdh_1, cdbt_1, cdb_1, cdrb_1, cdsf_1

            cdh_1 = cdh(M, ashell)
            cdbt_1 = cdbt(M, ashell)
            cdb_1 = cdb(M, ashell)
            cdrb_1 = cdrb(M, ashell)
            cdsf_1 = cdsf(M, ashell)

            cdh_= cdh_1
            cdbt_ = cdbt_1
            cdb_ = cdb_1
            cdrb_ = cdrb_1
            cdsf_ = cdsf_1

            cd0_ = cdh_1 + cdbt_1 + cdb_1 + cdrb_1 + cdsf_1

        end subroutine get_aerodynamics_

        subroutine get_aerodynamics(M, n_machs, ashell, cd0_array, cdh_array, cdbt_array, cdb_array, cdrb_array, cdsf_array) bind(c, name='get_aerodynamics')
            real(c_double), dimension(:), intent(in):: M(n_machs)
            integer(c_int), intent(in), value:: n_machs
            type(shell), intent(in):: ashell

            real(c_double), dimension(:), intent(inout):: cd0_array(n_machs), cdh_array(n_machs), cdbt_array(n_machs), cdb_array(n_machs), cdrb_array(n_machs), cdsf_array(n_machs)

            integer(c_int):: i

            do concurrent (i=1:n_machs)

                cdh_array(i) = cdh(M(i), ashell)
                cdbt_array(i) = cdbt(M(i), ashell)
                cdb_array(i) = cdb(M(i), ashell)
                cdrb_array(i) = cdrb(M(i), ashell)
                cdsf_array(i) = cdsf(M(i), ashell)

                cd0_array(i) = cdh_array(i) + cdbt_array(i) + cdb_array(i) + cdrb_array(i) + cdsf_array(i)

            end do
            
        end subroutine get_aerodynamics

end module mcdrag

module solve_ib
    use preproc
    use iso_c_binding
    implicit none

    private compute_om_sum, theta_av, compute_psi, pressure, int_bal_rs, k50
    real(c_double), parameter :: k50 = 50e6_dp ** 0.25_dp

    contains

        real(c_double) function compute_om_sum(charge) result(om_sum)
            type(powder), dimension(:), intent(in) :: charge

            integer(c_int) :: i, n_powd
            
            om_sum = 0.0_dp
            n_powd = size(charge)

            do i = 1, n_powd
                om_sum = om_sum + charge(i)%om
            end do
        end function compute_om_sum

        real(c_double) function theta_av(psis, ign, charge)
        ! Расчет осредненного(average) параметра расширения
            real(c_double), dimension(:), intent(in) :: psis
            type(igniter), intent(in) :: ign
            type(powder), dimension(:), intent(in) :: charge

            real(c_double) :: num, denum
            integer(c_int) :: i, n_powd

            n_powd = size(charge)
            num = ign%num
            denum = ign%denum

            do i = 1, n_powd
                num = num + charge(i)%f_powd * charge(i)%om * psis(i)/charge(i)%ti
                denum = denum + charge(i)%f_powd * charge(i)%om * psis(i)/(charge(i)%ti * charge(i)%theta)
            end do

            if (denum > 0.0_dp) then
                theta_av = num/denum
            else
                theta_av = 0.4_dp
            end if

        end function theta_av

        subroutine compute_psi(psis, z, charge)
            ! Расчет относительной массы сгоревшего пороха с записью в массив psis
            real(c_double), dimension(:), intent(inout) :: psis
            real(c_double), dimension(:), intent(in) :: z
            type(powder), dimension(:), intent(in) :: charge

            real(c_double) :: z1, psi_s 
            integer(c_int) :: i, n_powd

            n_powd = size(charge)

            do i = 1, n_powd
                if (z(i) < 1.0_dp) then
                    psis(i) = charge(i)%kappa1*z(i)*(1.0_dp + charge(i)%lambda1*z(i) + charge(i)%mu1*z(i)**2)
                elseif (z(i) < charge(i)%zk) then
                    z1 = z(i) - 1.0_dp
                    psi_s = charge(i)%kappa1*(1.0_dp + charge(i)%lambda1 + charge(i)%mu1)
                    psis(i) = psi_s + charge(i)%kappa2*z1*(1.0_dp + charge(i)%lambda2*z1 + charge(i)%mu2*z1**2)
                else
                    psis(i) = 1.0_dp
                end if

                if (psis(i) > 1.0_dp) then
                    psis(i) = 1.0_dp
                end if
                
            end do
        end subroutine compute_psi

        subroutine pressure(p, y, ign, barl, l_chi, om_sum, psis, charge, err_state)
            real(c_double), dimension(:), intent(inout) :: p(3)
            real(c_double), dimension(:), intent(in) :: y
            type(igniter), intent(in) :: ign
            type(barrel), intent(in) :: barl
            real(c_double), intent(in) :: l_chi
            real(c_double), intent(in) :: om_sum
            real(c_double), dimension(:), intent(in) :: psis
            type(powder), dimension(:), intent(in) :: charge
            integer(c_int), intent(out) :: err_state

            real(c_double) :: theta, fs, w
            integer(c_int) i, n_powd

            n_powd = size(charge)

            theta = theta_av(psis, ign, charge)
            fs = ign%fs
            w = barl%w0

            do i = 1, n_powd
                fs = fs + charge(i)%f_powd * charge(i)%om * psis(i)
                w = w - charge(i)%om*((1.0_dp - psis(i))/charge(i)%ro + psis(i)*charge(i)%alpha)
            end do

            fs = fs - theta*y(1)**2 * (0.5_dp * barl%q + l_chi*om_sum/6.0_dp)
            w = w + y(2)*barl%s
            if (w < 0.0_dp) then
                err_state = 1
                return
            end if

            p(1) = 1e5_dp + fs/w
            if (y(1) > 0.0_dp) then
                p(2) = p(1)/(1.0_dp + (1.0_dp/3.0_dp)*(l_chi*om_sum)/barl%q)
                p(3) = p(2)*(1.0_dp + 0.5_dp*l_chi*om_sum/barl%q)
            else
                p(2) = p(1)
                p(3) = p(1)
            end if

        end subroutine pressure

        subroutine int_bal_rs(dy, y, psis, p, p0, om_sum, ign, barl, charge, err_state)
            real(c_double), dimension(:), intent(out) :: dy
            real(c_double), dimension(:), intent(in) :: y
            real(c_double), dimension(:), intent(inout) :: psis
            real(c_double), dimension(:), intent(inout) :: p
            real(c_double), intent(in) :: p0
            real(c_double), intent(in) :: om_sum
            type(igniter), intent(in) :: ign
            type(barrel), intent(in) :: barl
            type(powder), dimension(:), intent(in) :: charge
            integer(c_int), intent(out) :: err_state

            real(c_double) :: l_chi
            integer(c_int) i, n_powd
            n_powd = size(charge)
            
            l_chi = (y(2) + barl%l_k)/(y(2) + barl%l0)

            call compute_psi(psis, y(3:), charge)
            call pressure(p, y, ign, barl, l_chi, om_sum, psis, charge, err_state)

            if (err_state == 1) then
                return
            end if

            if ((y(1) > 0.0) .or. (p(1) > p0)) then
                dy(1) = p(2) * barl%s/barl%q
                dy(2) = y(1)
            else
                dy(1) = 0.0_dp 
                dy(2) = 0.0_dp
            end if

            do i = 1, n_powd
                if (p(1) < 50e6_dp) then
                    dy(2 + i) = ((k50*p(1)**0.75_dp)/charge(i)%jk)
                else
                    dy(2 + i) = (p(1)/charge(i)%jk)
                end if
            end do

        end subroutine int_bal_rs

        subroutine count_ib(ibp, n_powd, charge, tstep, tend) bind(c, name='count_ib')

            type(ibproblem), intent(inout) :: ibp
            integer(c_int), intent(in), value :: n_powd
            type(powder), dimension(:), intent(inout) :: charge(n_powd)
            real(c_double), intent(in), value :: tstep, tend

            real(c_double), dimension(:, :) :: dy(2 + n_powd, 4)
            real(c_double), dimension(:) :: y(2 + n_powd)
            real(c_double), dimension(:) :: psis(n_powd)
            real(c_double), dimension(:) :: p(3)
            logical(c_bool) :: burned
            real(c_double) :: t0, om_sum, p0, psi_sum
            integer(c_int) :: i, err_state

            type(barrel) :: barl
            type(igniter) :: ign

            barl = ibp%artsystem
            barl%q = barl%q * barl%kf

            t0 = 0.0_dp
            dy = 0.0_dp
            y = 0.0_dp
            psis = 0.0_dp
            p = 1e5_dp

            burned = .false.
            err_state = 0
            om_sum = compute_om_sum(charge)
            p0 = ibp%p0

            call compute_igniter(ign, ibp, charge)

            call temp_account(charge, ibp%t0)

            do while (y(2) < barl%l_d)
                if (all(psis >= 1) .and. .not. burned) then
                    ibp%eta_k = y(2)/barl%l_d
                    burned = .true.
                end if

                call int_bal_rs(dy(:, 1), y, psis, p, p0, om_sum, ign, barl, charge, err_state)
                ibp%p_av_max = max(ibp%p_av_max, p(1))
                ibp%p_sn_max = max(ibp%p_sn_max, p(2))
                ibp%p_kn_max = max(ibp%p_kn_max, p(3))
                call int_bal_rs(dy(:, 2), y + 0.5_dp*tstep*dy(:, 1), psis, p, p0, om_sum, ign, barl, charge, err_state)
                call int_bal_rs(dy(:, 3), y + 0.5_dp*tstep*dy(:, 2), psis, p, p0, om_sum, ign, barl, charge, err_state)
                call int_bal_rs(dy(:, 4), y + tstep*dy(:, 3), psis, p, p0, om_sum, ign, barl, charge, err_state)

                if (err_state == 1) then
                    ibp%status = 1
                    return
                end if

                t0 = t0 + tstep
                y = y + tstep*(dy(:, 1) + 2*dy(:, 2) + 2*dy(:, 3) + dy(:, 4))/6
                
                if (t0 > tend) then
                    ibp%status = 2
                    return
                end if
            end do

            psi_sum = 0.0_dp

            call compute_psi(psis, y(3:), charge)

            do i = 1, n_powd
                psi_sum = psi_sum + psis(i) * charge(i)%om
            end do

            ibp%v0 = y(1)
            ibp%psi_sum = psi_sum/om_sum

        end subroutine count_ib

        subroutine dense_count_ib(ibp, n_powd, charge, tstep, tend,&
                                  n_tsteps, y_array, pressure_array) bind(c, name='dense_count_ib')

            type(ibproblem), intent(inout) :: ibp
            integer(c_int), intent(in), value :: n_powd
            integer(c_int), intent(inout) :: n_tsteps
            real(c_double), intent(inout) :: y_array(2 + n_powd, n_tsteps), pressure_array(3, n_tsteps)
            type(powder), dimension(:), intent(inout) :: charge(n_powd)
            real(c_double), intent(in), value :: tstep, tend

            real(c_double), dimension(:, :) :: dy(2 + n_powd, 4)
            real(c_double), dimension(:) :: psis(n_powd)
            real(c_double), dimension(:, :) :: p(3, 4)
            logical(c_bool) :: burned
            real(c_double) :: t0, om_sum, p0, psi_sum
            integer(c_int) :: i, err_state

            type(barrel) :: barl
            type(igniter) :: ign

            barl = ibp%artsystem
            barl%q = barl%q * barl%kf

            t0 = 0.0_dp
            y_array(:, 1) = 0.0_dp
            dy = 0.0_dp
            psis = 0.0_dp
            p = 1e5_dp

            burned = .false.
            err_state = 0
            om_sum = compute_om_sum(charge)
            p0 = ibp%p0

            call compute_igniter(ign, ibp, charge)

            call temp_account(charge, ibp%t0)

            do i = 2, n_tsteps
                if (all(psis >= 1) .and. .not. burned) then
                    ibp%eta_k = y_array(2, i-1)/barl%l_d
                    burned = .true.
                end if

                call int_bal_rs(dy(:, 1), y_array(:, i-1), psis, p(:, 1), p0, om_sum, ign, barl, charge, err_state)
                pressure_array(:, i-1) = p(:, 1)
                call int_bal_rs(dy(:, 2), y_array(:, i-1) + 0.5_dp*tstep*dy(:, 1), psis, p(:, 2), p0, om_sum, ign, barl,&
                 charge, err_state)
                call int_bal_rs(dy(:, 3), y_array(:, i-1) + 0.5_dp*tstep*dy(:, 2), psis, p(:, 3), p0, om_sum, ign, barl,&
                 charge, err_state)
                call int_bal_rs(dy(:, 4), y_array(:, i-1) + tstep*dy(:, 2), psis, p(:, 4), p0, om_sum, ign, barl, charge,&
                 err_state)

                if (err_state == 1) then
                    ibp%status = 1
                    return
                end if

                ibp%p_av_max = max(ibp%p_av_max, p(1, 1))
                ibp%p_sn_max = max(ibp%p_sn_max, p(2, 1))
                ibp%p_kn_max = max(ibp%p_kn_max, p(3, 1))

                t0 = t0 + tstep
                y_array(:, i) = y_array(:, i-1) + tstep*(dy(:, 1) + 2*dy(:, 2) + 2*dy(:, 3) + dy(:, 4))/6

                call compute_psi(y_array(3:2+n_powd, i-1), y_array(3:2+n_powd, i-1), charge)

                if (t0 > tend) then
                    ibp%status = 2
                    return
                end if

                if (y_array(2, i) > barl%l_d) then
                    call int_bal_rs(dy(:, 1), y_array(:, i), psis, p(:, 1), p0, om_sum, ign, barl, charge, err_state)
                    y_array(3:2+n_powd, i) = psis
                    pressure_array(:, i) = p(:, 1)
                    n_tsteps = i
                    exit
                end if
            end do

            psi_sum = 0.0_dp

            do i = 1, n_powd
                psi_sum = psi_sum + psis(i) * charge(i)%om
            end do

            ibp%v0 = y_array(1, n_tsteps)
            ibp%psi_sum = psi_sum/om_sum

        end subroutine dense_count_ib

end module solve_ib

module solve_ebh
    use iso_c_binding

    use solve_eb

    implicit none
    
    real(c_double), dimension(:), parameter :: km_list(25) = [0.97, 0.98, 1.0, 1.03, 1.06, 1.07, 1.06, 1.05, 1.04, 1.03, 1.02, 1.01,&
    1.0, 0.99, 0.98, 0.97, 0.96, 0.95, 0.94, 0.93, 0.92, 0.91, 0.9, 0.89, 0.88]

    real(c_double), dimension(:), parameter :: km_mach_list(25) =  [0.762, 0.821, 0.88, 0.938, 0.997, 1.173, 1.232, 1.291,&
    1.349, 1.467, 1.525, 1.643, 1.701, 1.76, 1.877, 1.995, 2.053, 2.171, 2.23, 2.347, 2.491, 2.64, 3.08, 3.227, 3.374]

    type, bind(c) :: shell
        real(c_double):: d
        real(c_double):: L
        real(c_double):: q
        real(c_double):: A
        real(c_double):: B
        real(c_double):: mu
        real(c_double):: c_q
        real(c_double):: h
    end type shell

    contains

    real(c_double) function get_km(v) result(km)
        real(c_double), intent(in):: v

        real(c_double):: mach
        integer(c_int) :: i


        mach = v / linear_interp(1.0_dp, h_list, a_list, 15)
        km = linear_interp(mach, km_mach_list, km_list, 25)

        km = km * 1e-3

    end function get_km

    subroutine ext_bal_rs_h(dy, y, cx_list, mach_list, n_machs, ashell)
        ! Функция правых частей вместе с угловой скоростью
        real(c_double), intent(out) :: dy(5)
        real(c_double), intent(in) :: y(5), cx_list(n_machs), mach_list(n_machs)
        type(shell), intent(in):: ashell

        integer(c_int), intent(in):: n_machs

        real(c_double):: hy

        hy = rho_0 * ((20000.0 - y(2)) / (20000.0 + y(2)))

        call ext_bal_rs(dy(:4), y(:4), ashell%d, ashell%q, cx_list, mach_list, n_machs)

        dy(5) = -ashell%d ** 3 * ashell%L / ashell%A * 1e3_dp * hy * y(3) * 1.5e-6_dp * y(5)

    end subroutine ext_bal_rs_h

    subroutine dense_count_eb_h(y_array, cx_list, mach_list, n_machs, ashell, diag_vals, eta, sigma_dop, delta_dop, sigma_array, delta_array, max_distance, tstep, tmax, n_tsteps) bind(c, name="dense_count_eb_h")
        real(c_double), intent(inout) :: y_array(5, n_tsteps), diag_vals(4), sigma_array(n_tsteps), delta_array(n_tsteps), cx_list(n_machs), mach_list(n_machs)
        type(shell), intent(in):: ashell
        integer(c_int), intent(inout) :: n_tsteps
        integer(c_int), intent(in), value:: n_machs
        real(c_double), intent(in), value :: max_distance, tstep, tmax, eta, sigma_dop, delta_dop
        ! real(c_double), intent(in):: sigma_dop, delta_dop

        real(c_double) :: dy(5, 4), t0, d
        integer(c_int) :: i, i_s
        i_s = 0

        d = ashell%d * 1e-3_dp

        t0 = 0.0

        y_array(5, 1) = 2.0_dp * pi * y_array(3, 1) / (eta * ashell%d)

        do i=2, n_tsteps
            call compute_sigma_delta(ashell, y_array(:, i-1), sigma_array(i-1), delta_array(i-1)) ! Расчет коэффициента гироскопической устойчивости и угла нутации

            call ext_bal_rs_h(dy(:, 1), y_array(:, i-1), cx_list, mach_list, n_machs, ashell)
            call ext_bal_rs_h(dy(:, 2), y_array(:, i-1) + 0.5*tstep*dy(:, 1), cx_list, mach_list, n_machs, ashell)
            call ext_bal_rs_h(dy(:, 3), y_array(:, i-1) + 0.5*tstep*dy(:, 2), cx_list, mach_list, n_machs, ashell)
            call ext_bal_rs_h(dy(:, 4), y_array(:, i-1) + tstep*dy(:, 3), cx_list, mach_list, n_machs, ashell)
            t0 = t0 + tstep
            y_array(:, i) = y_array(:, i-1) + tstep*(dy(:, 1) + 2*dy(:, 2) + 2*dy(:, 3) + dy(:, 4))/6

            if ((y_array(2, i) - y_array(2, i-1) < 0.0_dp) .and. (i_s == 0)) then
                i_s = i
            end if

            if(y_array(2, i) < 0.0 .or. y_array(1, i) > max_distance) then
                n_tsteps = i
                exit
            end if
            if(t0 > tmax) then
                n_tsteps = i
                return
            end if
        end do

        if (y_array(2, n_tsteps) < 0.0) then
            y_array(:, n_tsteps) = y_array(:, n_tsteps-1) + (0.0 - y_array(2, n_tsteps-1)) * ((y_array(:, n_tsteps)-y_array(:, n_tsteps-1))/(y_array(2, n_tsteps)-y_array(2, n_tsteps-1)))
        end if
        if (y_array(1, n_tsteps) > max_distance) then
            y_array(:, n_tsteps) = y_array(:, n_tsteps-1) + (max_distance - y_array(1, n_tsteps-1)) * ((y_array(:, n_tsteps)-y_array(:, n_tsteps-1))/(y_array(1, n_tsteps)-y_array(1, n_tsteps-1)))
        end if

        call compute_sigma_delta(ashell, y_array(:, n_tsteps), sigma_array(n_tsteps), delta_array(n_tsteps))
        call compute_diagram(y_array(:, 1), y_array(:, i_s), diag_vals, ashell, sigma_dop, delta_dop)

    end subroutine dense_count_eb_h

    subroutine compute_sigma_delta(ashell, y_s, sigma_i, delta_i)
        type(shell), intent(in):: ashell
        real(c_double), intent(in):: y_s(5)
        real(c_double), intent(inout):: sigma_i, delta_i

        real(c_double):: beta, alpha, h_y, k_ms, d, h, sqrt_l

        h = ashell%h
        d = ashell%d
        k_ms = get_km(y_s(3))
        h_y = (20000.0 - y_s(2)) / (20000.0 + y_s(2))

        if (ashell%L <= 4.5_dp * d) then
            sqrt_l = 1.0_dp
        else
            sqrt_l = sqrt(ashell%L / (4.5_dp * d))
        end if

        beta = (d ** 2 * h * 1e3_dp * h_y * y_s(3) ** 2 * k_ms * sqrt_l) / ashell%B

        alpha = 0.5_dp * ashell%A / ashell%B * y_s(5)

        sigma_i = 1.0_dp - beta / alpha ** 2

        if (sigma_i > 0.0_dp) then
            sigma_i = sqrt(sigma_i)
        else
            sigma_i = 0.0_dp
        end if

        delta_i = (2.0_dp * alpha / beta) * (g * cos(y_s(4)) / y_s(3))

    end subroutine compute_sigma_delta

    subroutine compute_diagram(y_0, y_s, diag_vals, ashell, sigma_dop, delta_dop)
        real(c_double), intent(inout):: y_0(5), y_s(5), diag_vals(4)
        real(c_double), intent(in):: sigma_dop, delta_dop
        type(shell), intent(in):: ashell

        real(c_double):: km_s, km_0, m, n, hd_kr, eta_kr, c_q, mu, d, omega_0, omega_s, h_y, sqrt_l

        d = ashell%d

        h_y = (20000.0 - y_s(2)) / (20000.0 + y_s(2))

        mu = ashell%mu

        c_q = ashell%c_q

        if (ashell%L <= 4.5_dp * d) then
            sqrt_l = 1.0_dp
        else
            sqrt_l = sqrt(ashell%L / (4.5_dp * d))
        end if

        km_0 = get_km(y_0(3))
        km_0 = km_0 * sqrt_l

        m = mu * c_q * (1.0_dp - sigma_dop ** 2) * pi ** 2
        m = m / (4.0_dp * km_0 * ashell%B / ashell%A)

        km_s = get_km(y_s(3))

        km_s = km_s * sqrt_l

        omega_0 = y_0(5)

        omega_s = y_s(5)

        n = (mu * c_q * y_0(3) * d) / (km_s * delta_dop * h_y * y_s(3) ** 3)

        n = 0.5_dp * pi * g * n

        n = n * omega_s / omega_0

        eta_kr = n / m
        hd_kr = n ** 2 / m

        diag_vals(1) = m
        diag_vals(2) = n
        diag_vals(3) = hd_kr
        diag_vals(4) = eta_kr

        ! diag_vals - результаты расчета
        ! 1 - m расчетное
        ! 2 - n расчетное
        ! 3 - m критическое
        ! 4 - n критическое

    end subroutine compute_diagram

end module solve_ebh

      SUBROUTINE S4
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BET
      COMMON/DATA1/C(240),C1(240),B(240),C3
      COMMON/DFO/FIO,FIOX,FIOR,FIOXX,FIOXR,FIORR
      COMMON/DF1/FI1,FI1X,FI1R,XIOX,XIOR
      COMMON/DISC/R1,PI,I,JH,J,KL
      BETA=BET
      CT=R1*C(J)
      C1T=R1*C1(J)
      BT=R1*B(J)
      X=XB(I)-XB(J-1)+BETA*RB(J-1)
      T=BETA*RB(I)/X
      IF(T.GT.0.999999D0) T=0.999999D0
      T2=T**2
      F2=DSQRT(1.D0-T2)
      F3=F2/T
      F1=DLOG(1.D0/T+F3)
      F5=X*(F3-T*F1)
      F6=2.D0*X*(F1-F2)
      F7=-BETA*(F3/T+F1)
      FIO=FIO+0.5D0*CT*X*(T*F5-F6)
      FIOX=FIOX-CT*F6
      FIOR=FIOR+BETA*CT*F5
      FIOXX=FIOXX-2.D0*CT*F1
      FIOXR=FIOXR+2.D0*BETA*CT*F3
      FIORR=FIORR+BETA*CT*F7
      FI1=FI1+0.5D0*BT*F5
      FI1X=FI1X+BT*F3
      FI1R=FI1R+0.5D0*BT*F7
      XIOX=XIOX-C1T*F6
      XIOR=XIOR+BETA*C1T*F5
      RETURN
      END
      

module ibstructs

    use iso_c_binding
    implicit none
    integer, parameter:: dp=(kind(0.d0))

    type, bind(c) :: barrel

        real(c_double):: d
        real(c_double):: q
        real(c_double):: s
        real(c_double):: w0
        real(c_double):: l_d
        real(c_double):: l_k
        real(c_double):: l0
        real(c_double):: kf

    end type barrel

    type, bind(c) :: powder

        real(c_double):: om
        real(c_double):: ro
        real(c_double):: f_powd
        real(c_double):: ti
        real(c_double):: jk
        real(c_double):: alpha
        real(c_double):: theta
        real(c_double):: zk
        real(c_double):: kappa1
        real(c_double):: lambda1
        real(c_double):: mu1
        real(c_double):: kappa2
        real(c_double):: lambda2
        real(c_double):: mu2
        real(c_double):: gamma_f
        real(c_double):: gamma_jk

    end type powder

    type, bind(c) :: igniter

        real(c_double):: fs
        real(c_double):: num
        real(c_double):: denum

    end type igniter

    type, bind(c) :: ibproblem

        ! Исходные данные
        type(barrel):: artsystem
        real(c_double):: p0
        real(c_double):: pv
        real(c_double):: ig_mass
        real(c_double):: t0
        ! Расчетные параметры
        real(c_double):: v0
        real(c_double):: p_av_max
        real(c_double):: p_sn_max
        real(c_double):: p_kn_max
        real(c_double):: psi_sum
        real(c_double):: eta_k

        ! Статус ошибки (0-нет ошибки, 1-слишком много пороха, 2-превышено время выстрела)
        integer(c_int):: status

    end type ibproblem

    contains

    subroutine hello_from_fortran() bind(c, name="hello_from_fortran")
        print *, "hello from fortran"
    end subroutine hello_from_fortran

    subroutine set_problem(problem, p0, pv, ig_mass, t0) bind(c, name='set_problem')

        real(c_double), intent(in), value :: p0, pv, ig_mass, t0
        type(ibproblem), intent(inout) :: problem

        ! Исходные данные
        problem%p0 = p0
        problem%pv = pv
        problem%ig_mass = ig_mass
        problem%t0 = t0

        ! Расчетные значения
        problem%v0 = 0.0_dp
        problem%p_av_max = 1e5_dp
        problem%p_sn_max = 1e5_dp
        problem%p_kn_max = 1e5_dp
        problem%psi_sum = 0.0_dp
        problem%eta_k = 0.0_dp

        problem%status = 0

    end subroutine set_problem

    subroutine set_barrel(prob, d, q, s, w0, l_d, l_k, l0, kf) bind(c, name='set_barrel')

        type(ibproblem), intent(inout) :: prob
        real(c_double), intent(in), value :: d, q, s, w0, l_d, l_k, l0, kf

        type(barrel) :: barl

        barl = barrel(d, q, s, w0, l_d, l_k, l0, kf)

        prob%artsystem = barl

    end subroutine set_barrel

    subroutine add_powder(n_powd, powd_array, i, om, ro, f_powd, ti, jk, alpha, theta, zk, kappa1, lambda1, mu1,&
        kappa2, lambda2, mu2, gamma_f, gamma_jk) bind(c, name='add_powder')

        integer(c_int), intent(in), value :: n_powd
        type(powder), dimension(:), intent(inout) :: powd_array(n_powd)
        integer(c_int), intent(in), value :: i
        real(c_double), intent(in), value :: om, ro, f_powd, ti, jk, alpha, theta, zk, kappa1, lambda1, mu1,&
        kappa2, lambda2, mu2, gamma_f, gamma_jk

        type(powder) :: powd

        powd = powder(om, ro, f_powd, ti, jk, alpha, theta, zk, kappa1, lambda1, mu1,&
        kappa2, lambda2, mu2, gamma_f, gamma_jk)

        powd_array(i) = powd

    end subroutine add_powder

    real(c_double) function get_v0(prob) result(v0) bind(c, name='get_v0')

        type(ibproblem), intent(in) :: prob

        v0 = prob%v0

    end function get_v0

    real(c_double) function get_p_av_max(prob) result(p_av_max) bind(c, name='get_p_av_max')

        type(ibproblem), intent(in) :: prob

        p_av_max = prob%p_av_max

    end function get_p_av_max

    real(c_double) function get_psi_sum(prob) result(psi_sum) bind(c, name='get_psi_sum')

        type(ibproblem), intent(in) :: prob

        psi_sum = prob%psi_sum

    end function get_psi_sum

    real(c_double) function get_eta_k(prob) result(eta_k) bind(c, name='get_eta_k')

        type(ibproblem), intent(in) :: prob

        eta_k = prob%eta_k

    end function get_eta_k

    integer(c_int) function get_status(prob) result(status) bind(c, name='get_status')

        type(ibproblem), intent(in) :: prob

        status = prob%status

    end function get_status

end module ibstructs

      SUBROUTINE GEOM
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION RAB1(10),RAB2(10)
      COMMON/ICOU/VOLN,SOBS,RJA1,RJA2,ICOUNT,NGOL,NHBS
      COMMON/GEO2/NFL,NN,IPRINT,MAL,MAX,IPR
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BETA
      COMMON/RX/XR(20,6),G(20),GCH,DM,N,N1(20),IX,I1
      COMMON/NNI/NTT(11),NP5,JZT
      COMMON/GEO3/VOVS,AL,YINT,O,RR,RREF,AREF,DLN
      COMMON/DISC/R1,PI,I9,JH1,J9,KL
      COMMON/DIS2/SUM1,SUM2,SUM3,SUM4,SUM5,SUM6
      COMMON/VOL/CAF,CNF,CMF,CMX,DIA,RN,AP,XP
      COMMON/WAVE/CABL,CNBL,CMBL,CAW,CNW,CMW
      COMMON/PREOBR/PREB(10),RAB1,RAB2,IPE,NPR,NUPR
      COMMON/CVP/CXT(240),CNT(240),CMT(240),CPV(21),JA,JB,KF
      UKST=0.125D0
      NP5=15
      C3=C2
      BETA=DSQRT(DABS(VOVS**2-1.D0))
      KF=11
      IF(BETA.LE.0.5D0) BETA=0.5D0
      JZT=0
      JA=1
      JB=NP5
      BET1=BETA
      IF(BET1.GT.1.D0) BET1=1.D0
      CABL=0.D0
      CNBL=0.D0
      CMBL=0.D0
      F=O-AL*0.1D0
      IF(RR.LE.1.0D-6) GO TO 5
      IF(NFL.NE.1) GO TO 3
      H1=YINT/(NP5-1.)
      DO 4 J=1,NP5
      XB(J)=-YINT+H1*(J-1)
      RB(J)=DSQRT(DABS((XB(J)+YINT)*(RR**2-XB(J)*YINT)/YINT))
      IF(RB(J).LE.1.0D-10) RB(J)=1.0D-10
      RBP(J)=(RR**2/YINT-2.D0*XB(J)-YINT)/(2.D0*RB(J))
  4   END DO
  3   IF(VOVS.GT.1.26D0)CALL NEWT
      IF(NFL.NE.1.OR.VOVS.LE.1.26) GO TO 5
      CALL SIMP
      CABL=2.D0*SUM1/AREF
      CNBL=-2.D0*SUM2/AREF
      CMBL=SUM3/(AREF*RREF)
  5   CONTINUE
      S1=XR(2,1)+1.0D-10
      CALL SCHAPE(S1,R1,DRB)
      TETT=DATAN(DRB)
      XM=-RR/0.7D0
      TETX=0.4795D0
      IF(VOVS.GT.2.D0)TETX=F*DASIN(1.D0/VOVS)
      IF(TETX.LT.TETT) TETX=TETT
      STX=DSIN(TETX)
      CTX=DCOS(TETX)
      TNX=STX/CTX
      YM=0.5D0*XM*(TNX+DRB)+RR
      K=1
      XB(1)=XM-YM/TNX
      RB(1)=0.D0
      RBP(1)=TNX
      IF(RR.LT.1.0D-6) GO TO 40
      XB(2)=XM
      RB(2)=YM
      RBP(2)=TNX
      EC=RR
      EB=DRB
      EA=(TNX-DRB)/(2.D0*XM)
      VOV=VOVS
      IF(VOVS.LE.1.19D0)VOV=1.0001D0
      E=16.D0/VOV**2
      IF(E.LT.3.D0)E=3.D0
      S2=0.7D0
  43  S1=S2*(TETX/0.5236D0)**2/VOV**E
      DO 42 K=3,100
      A=K-2.D0
      S3=XB(K-1)+RB(K-1)*DSQRT(A)*S1
      RB(K)=EA*S3**2+EB*S3+EC
      RBP(K)=2.D0*EA*S3+EB
      XB(K)=S3
      IF(S3.GE.0.D0) GO TO 40
   42 END DO
      S2=1.2D0*S2
      GO TO 43
   40 EP=1.0D-10
      NTT(1)=K-1
      J1=2
   46 C3=1.2D0*C3
      K=NTT(1)
      DO 10 J=J1,N
      K=K+1
      IJ=0
      I1=11
      XB(K)=XR(J,1)
      CALL SCHAPE(XB(K)+EP,RB(K),RBP(K))
      IF(J.GT.2) RB(K)=RB(K-1)
   11 K=K+1
      IJ=IJ+1
      C5=IJ*C3
      IF(K.GT.240) GO TO 46
      P1=C5*BET1*RB(K-1)
      IF(P1.GT.UKST) P1=UKST
      XB(K)=XB(K-1)+P1
      IF(K.EQ.2) XB(2)=0.005D0+XB(1)
      IF(XB(K).GE.XR(J,2)) GO TO 7
      CALL SCHAPE(XB(K),RB(K),RBP(K))
      GO TO 11
    7 CONTINUE
      XB(K)=XR(J,2)
      CALL SCHAPE(XB(K)-EP,RB(K),RBP(K))
      NTT(J)=K
  10  END DO
      NN=NTT(N)
      SUM3=0.D0
      SUM4=0.D0
      SUM1=PI*(YINT**2+RR**2)
      C22=0.D0
      IF(RJA1.EQ.0.) RJA1=0.37D0*DLN
      PRMX=0.D0
      SUM2=PI*YINT*(3.D0*RR**2+YINT**2)/6.D0
      DO 1 J=2,N
      JB=NTT(J)-1
      JA=NTT(J-1)+1
      DO 1 I=JA,JB
      XI=XB(I)
      XI1=XB(I+1)
      RI=RB(I)
      DX=XI1-XI
      RI1=RB(I+1)
      SUM3=SUM3+DX*(RI+RI1)
      SUM4=SUM4+DX*(XI1*RI1+XI*RI)
      SUM2=SUM2+PI/2.D0*DX*(RI**2+RI1**2)
      IF(J.EQ.NGOL) VOLN=SUM2
      C22=C22+2.D0*DX*(XI*RI*RI+XI1*RI1*RI1)
      IF(J.EQ.NHBS) VOLN1=SUM2
      S1=DABS(RBP(I))
      IF(PRMX.LT.S1) PRMX=S1
      SUM1=SUM1+PI*DX*(RI*DSQRT(1.D0+RBP(I)**2)+RI1*DSQRT
     *(1.D0+RBP(I+1)**2))
  1   Continue
      C22=4.D0*(DLN-RJA1/DIA)*SUM2/PI-C22
      CMQ=-4.D0*(4.D0*RB(NN)**2*RJA1/DIA+C22)
      SOBS=SUM1
      AB=SUM3
      XP=SUM4/SUM3
      RJA2=CMQ
      IF(IPE.EQ.0) NUPR=NPR
      IF(IPE.EQ.0.OR.NPR.EQ.NUPR) GO TO 14
      NUPR=NPR
  14  CONTINUE
      FI=DATAN(PRMX)/F
      SNFI=DSIN(FI)
      IF(SNFI.LE.1.D0/VOVS.AND.VOVS.LE.3.D0)GOTO2
      JZT=1
      SUM6=1./SNFI
      IF(SUM6.GT.3.D0) SUM6=3.0D0
      JA=NTT(1)+1
      JB=NN
      SUM6=SUM6*0.98D0
  2   IF(JZT.EQ.1) CALL NEWT
      RETURN
      END

      SUBROUTINE HYBRID
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION THEC(21),THES(21),C3I(21)
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BET
      COMMON/GEO2/NFL,NN,IPRINT,MAL,MAX,IPR
      COMMON/RX/XR(20,6),G(20),GCH,DM,N,N1(20),IX,I1
      COMMON/ICOU/VOLN,SOBS,RJA1,RJA2,ICOUNT,NGOL,NHBS
      COMMON/DFO/FIO,FIOX,FIOR,FIOXX,FIOXR,FIORR
      COMMON/DF1/FI1,FI1X,FI1R,XIOX,XIOR
      COMMON/GEO3/VOVS,AL,YINT,F,RR,RREF,AREF,DLN
      COMMON/NNI/NTT(11),NP5,JZT
      COMMON/DATA1/C(240),C1(240),B(240),C3
      COMMON/DISC/R1,PI,I,JH,J,KL
      COMMON/WAVE/CABL,CNBL,CMBL,CAW,CNW,CMW
      COMMON/CVP/CXT(240),CNT(240),CMT(240),CPV(21),JA,JB,KF
      IF(JZT.EQ.1) GO TO 108
      ER=1.D0/(.2D0*VOVS**2)+1.D0-.0001D0
      AS1=2.D0/(1.4D0*VOVS**2)
      AS2=0.2D0*VOVS**2
      AS3=AS2+1.D0
      COSAL=DCOS(AL)
      SINAL=DSIN(AL)
      DF=PI/(KF-1.)
      BETA=BET
      VOV2=VOVS**2
      BET2=BETA**2
      NTS=NTT(NHBS)
      CF=-.060D0
      DO 47 IJ=1,KF
      TET=(IJ-1)*DF
      THEC(IJ)=DCOS(TET)
      THES(IJ)=DSIN(TET)
  47  END DO
      TA=RBP(1)
      TA2=TA**2
      T=BETA*TA
      T2=T**2
      F2=DSQRT(1.D0-T2)
      F1=DLOG((1.D0+F2)/T)
      SC=TA2/(F2+TA2*F1)
      FIO=SC*(F2-F1)
      FIOX=-SC*F1
      FIOR=SC*F2/TA
      FIOXX=-SC/F2
      FIOXR=SC/(F2*TA)
      FIORR=FIOXX/TA2
      PC=(1.D0+0.2D0*VOV2*TA2)*0.55D0/F2**2
      AN=1.2D0*VOV2/BET2
      ANT=AN*TA
      S=FIO+ANT*FIOR
      PSIX=VOV2*(S*FIOXX+FIOX*(FIOX+ANT*FIOXR)-
     *0.75D0*TA*FIOR**2*FIOXR*PC)
      PSIR=VOV2*(S*FIOXR+FIOX*((1.D0+AN)*
     *FIOR+ANT*FIORR)-0.25D0*FIOR**2*(FIO
     *R+3.D0*TA*FIORR)*PC)
      SC1=TA*(TA*(1.D0+PSIX)-PSIR)/(F2+TA2*F1)
      C(1)=SC
      C1(1)=SC1
      AB=SC1/SC
      PHIR=PSIR+AB*FIOR
      PHIX=PSIX+AB*FIOX
      SB=2.D0*BETA*TA2/((1.D0+2.D0*TA2)*F2+T**2*F1)
      B(1)=SB
      FI1=0.5D0*SB*(F2/T-T*F1)
      FI1X=SB*F2/T
      FI1R=-0.5D0*SB*BETA*(F2/T2+F1)
      SU1=COSAL*(1.D0+PHIX)
      SU2=SINAL*FI1X
      SV1=COSAL*PHIR
      SV2=SINAL*(1.D0+FI1R)
      SW1=-SINAL*(1.D0+FI1/TA)
      DO 53 IJ=1,KF
      COST=THEC(IJ)
      UB=SU1+SU2*COST
      VB=SV1+SV2*COST
      WB=SW1*THES(IJ)
      QB=UB**2+VB**2+WB**2
      CP=AS1*(DSQRT((AS3-AS2*QB)**7)-1.D0)
      CPV(IJ)=CP
  53  END DO
      I=1
      CALL POPIN
      IK=2
      DO 7 I=2,NN
      RBI=RB(I)
      RBPI=RBP(I)
      XBI=XB(I)
      X=XBI-XB(I-1)+BETA*RB(I-1)
      T=BETA*RBI/X
      IF(T.GT.0.999999D0) T=0.999999D0
      T2=T**2
      X0=XBI-XB(1)
      T0=BETA*RBI/X0
      T02=T0**2
      F20=DSQRT(1.D0-T02)
      F30=F20/T0
      F10=DLOG(1.D0/T0+F30)
      F50=X0*(F30-T0*F10)
      R1=1.D0
      F2=DSQRT(1.D0-T2)
      F3=F2/T
      F1=DLOG(1.D0/T+F3)
      F5=X*(F3-T*F1)
      F6=2.D0*X*(F1-F2)
      F7=-BETA*(F3/T+F1)
      DENC=BETA*F5+RBPI*F6
      DENB=0.5D0*F7-RBPI*F3
      FIO=SC*X0*(F20-F10)
      FIOX=-SC*F10
      FIOR=BETA*SC*F30
      FIOXX=-SC/(X0*F20)
      FIOXR=-FIOXX*BETA/T0
      FIORR=FIOXX*BET2/T02
      FI1=0.5D0*SB*F50
      FI1R=-0.5D0*SB*BETA*(F30/T0+F10)
      FI1X=SB*F30
      XIOX=-SC1*F10
      XIOR=BETA*SC1*F30
      IQ=NTT(2)+1
      IF(I.EQ.2) GO TO 36
      KL=1
      J2=I-1
      DO 8 J=2,J2
      CALL S4
 8    END DO
      DO 1 KR=2,N
      JH=NTT(KR)+1
      IQ=JH
      C3=C3I(KR)
      IF(I.LE.JH) GO TO 36
      CALL DISCO
      J=JH
      R1=-1.D0
      CALL S4
   1  END DO
   36 CT=(RBPI*(1.D0+FIOX)-FIOR)/DENC
      BT=(RBPI*FI1X-1.D0-FI1R)/DENB
      JL=NTT(IK)+1
      IF(I.LT.JL) GO TO 10
      RBPB=RBP(JL)
      RBPA=RBP(JL-1)
      S1=(RBPB-RBPA)/(BETA+RBPB)
      CT=S1*(1.D0+FIOX)
      BT=-S1*FI1X*BETA
   10 C(I)=CT
      B(I)=BT
      KL=2
      JH=IQ
      IF(I.LT.JH) GO TO 11
      CALL DISCO
      GO TO 12
   11 FIO=FIO+0.5D0*CT*X*(T*F5-F6)
      FIOX=FIOX-CT*F6
      FIOR=FIOR+BETA*CT*F5
      FIOXX=FIOXX-2.D0*CT*F1
      FIOXR=FIOXR+2.D0*BETA*CT*F3
      FIORR=FIORR+BETA*CT*F7
      FI1=FI1+0.5D0*BT*F5
      FI1X=FI1X+BT*F3
      FI1R=FI1R+0.5D0*BT*F7
   12 CONTINUE
      ANT=AN*RBI
      P=FIO+ANT*FIOR
      PS=VOV2*(P*FIOX-0.25D0*RBI*FIOR**3*PC)
      IF(JL.EQ.I) C3I(IK)=PS-PSI
      PSI=PS
      PSIXA=PSIX
      PSIRA=PSIR
      PSIX=VOV2*(P*FIOXX+FIOX*(FIOX+ANT*FIOXR)-
     *0.75D0*RBI*FIOR**2*FIOXR*PC
     *)
      PSIR=VOV2*(P*FIOXR+FIOX*((1.D0+AN)*
     *FIOR+ANT*FIORR)-0.25D0*FIOR**2*(FIO
     *R+3.D0*RBI*FIORR)*PC)
      C1T=(RBPI*(1.D0+XIOX+PSIX)-XIOR-PSIR)/DENC
      IF(I.LT.JL) GO TO 13
      C3=C3I(IK)
      IK=IK+1
      C1T=S1*(1.D0+XIOX)+((RBPB/BETA-3.D0)*C3/
     *(8.D0*RB(JL))+PSIRA-PSIR+RBPB*PS
     *IX-RBPA*PSIXA)/(BETA+RBPB)
   13 C1(I)=C1T
      IF(I.LT.JH) GO TO 14
      KL=3
      CALL DISCO
      GO TO 15
   14 XIOX=XIOX-C1T*F6
      XIOR=XIOR+BETA*C1T*F5
   15 CONTINUE
      IF(I.LE.NTS) GO TO 502
      PHIX=FIOX
      PHIR=FIOR
      GO TO 505
  502 PHIX=PSIX+XIOX
      PHIR=PSIR+XIOR
  505 SU1=COSAL*(1.D0+PHIX)
      SV1=COSAL*PHIR
      IF(RBPI.GE.0.D0) GO TO 2
      IF(FI1X.LE.CF) FI1X=CF
      IF(FI1R.GT.-1.D0) FI1R=-1.0001D0
    2 SU2=SINAL*FI1X
      SV2=SINAL*(1.D0+FI1R)
      SW1=-SINAL*(1.D0+FI1/RBI)
      DO 48 IJ=1,KF
      COST=THEC(IJ)
      UB=SU1+SU2*COST
      VB=SV1+SV2*COST
      WB=SW1*THES(IJ)
      QB=UB**2+VB**2+WB**2
      IF(QB.GT.ER)QB=ER
      CPV(IJ)=AS1*(DSQRT((AS3-AS2*QB)**7)-1.D0)
 48   END DO
      CALL POPIN
  7   END DO
 108  CALL NAVE
      RETURN
      END

program test
    use penetration
    implicit none


    type(hedge):: heg
    type(kernel):: ker
    type(pen_prob):: prob
    real(c_double):: ys(4, 1000)
    integer(c_int):: n_tsteps = 1000, i=1

    call set_hedge_material(heg, 970e6_dp, 7850.0_dp, 4.5_dp, 1.3_dp)
    call set_kernel_material(ker, 970e6_dp, 7850.0_dp, 4.01_dp, 1.5_dp)

    call init_hedge(heg, 201e9_dp, 0.33_dp, 0.95_dp)
    call init_kernel(ker, 4500.0_dp, 0.044_dp, 0.367_dp, 1733.0_dp)

    call dense_compute_penetration(ys, n_tsteps, prob, ker, heg, 1e-6_dp, 1.0_dp)

    do i=1, n_tsteps

        print *, ys(:, i)
    end do
    
end program test

      SUBROUTINE NAVE
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/WAVE/CABL,CNBL,CMBL,CAW,CNW,CMW
      COMMON/DIS2/SUM1,SUM2,SUM3,SUM4,SUM5,SUM6
      COMMON/CVP/CXT(240),CNT(240),CMT(240),CPV(21),JA,JB,KF
      COMMON/RX/XR(20,6),G(20),GCH,DM,N,N1(20),IX,I1
      COMMON/NNI/NTT(11),NP5,JZT
      COMMON/GEO3/VOVS,AL,YINT,F,RR,RREF,AREF,DLN
      CAW=0.D0
      CNW=0.D0
      CMW=0.D0
      NK1=N-1
      DO 1 J=1,NK1
      JA=NTT(J)+1
      JB=NTT(J+1)
      CALL SIMP
      CMW=CMW+2.D0*SUM3/(AREF*2.D0*RREF)
      CAW=CAW+2.D0*SUM1/AREF
      CNW=CNW-2.D0*SUM2/AREF
  1   END DO
      CAW=CAW+CABL
      CNW=CNW+CNBL
      CMW=CMW+CMBL
      RETURN
      END

      SUBROUTINE PREBR(J1)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION RAB1(10),RAB2(10)
      COMMON/PREOBR/PREB(10),RAB1,RAB2,IPE,NPR,NUPR
      COMMON/RX/XR(20,6),G(20),GCH,DM,N,N1(20),IX,I1
      S=XR(J1,1)
      DO 1 I=J1,N
      S=S+XR(I,2)-XR(I,1)+PREB(I)
      XR(I,2)=S
1     END DO
      DO 2 I=J1,N
      XR(I,1)=XR(I-1,2)
      IF(N1(I).EQ.4.OR.N1(I).EQ.3) GO TO 3
      GO TO 2
    3 Q=XR(I,2)-XR(I,1)
      S=XR(I,4)-XR(I,3)
      TET=DATAN(RAB1(I))
      SNT=DSIN(TET)
      CST=DCOS(TET)
      XR(I,5)=(S**2+Q**2)/(2.D0*(S*CST-Q*SNT))
    2 END DO
      IF(N1(N).EQ.2) XR(N,4)=XR(N,3)+RAB2(1)*(XR(N,2)-XR(N,1))
      RETURN
      END

      SUBROUTINE DISCO
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BET
      COMMON/DATA1/C(240),C1(240),B(240),C3
      COMMON/DFO/FIO,FIOX,FIOR,FIOXX,FIOXR,FIORR
      COMMON/DF1/FI1,FI1X,FI1R,XIOX,XIOR
      COMMON/DISC/R1,PI,I,JH,J,KL
      REAL *8 K
      BETA=BET
      CT=C(JH)
      C1T=C1(JH)
      BT=B(JH)
      X=XB(I)-XB(JH-1)+BETA*RB(JH-1)
      T=BETA*RB(I)/X
      IF(T.GT.0.999999D0) T=0.999999D0
      T2=T**2
      TP1=1.D0+T
      CAP=DSQRT((1.D0-T)/TP1)
      CALL DCEL(K,E,CAP)
      A=DSQRT(2.D0*T*RB(JH)/(RB(I)*TP1))/PI
      A1=A*X*TP1
      A2=A/(X*(1.D0-T))
      A3=4.D0*DSQRT(RB(JH)*TP1*0.5D0/(T*RB(I)))/(3.D0*PI)
      F1X=-4.D0*A1*(K-E)
      F1XX=-2.D0*A*K
      F2XX=A2*(K-E)
      F1R=4.D0*BETA*A1*(E/T-K)/3.D0
      F2XR=BETA*A2*(E/T-K)
      F1XR=2.D0*BETA*A*(TP1*E/T-K)
      IF(T.LT.0.9999D0) GO TO 1
      SR8=0.125D0/RB(I)
      F1X=0.D0
      F1R=0.D0
      F1XX=-1.D0
      F2XX=SR8/BETA
      F2XR=3.D0*SR8
      F1XR=BETA
    1 IF(KL.EQ.3) GO TO 3
      F1=-8.D0*A1*X*((3.D0+T)*K-4.D0*E)/9.D0
      F1RR=-2.D0*BETA**2*A*(2.D0*TP1*E/T2-(2.D0-T)*K/T)/3.D0
      F2RR=-BETA**2*A2*((2.D0-T2)*E/T2-(2.D0-T)*K/T)
      F4=2.D0*A3*X*(E-T*K)/BETA
      F4X=3.D0*A3*(E-T*K/TP1)/BETA
      F4R=-2.D0*A3*(E/T-(2.D0-T)*0.5D0*K/TP1)
      IF(T.LT.0.9999D0) GO TO 2
      F1=0.D0
      F1RR=-BETA**2
      F2RR=-7.D0*BETA*SR8
      F4=0.D0
      F4X=1.D0/BETA
      F4R=-1.D0
    2 CONTINUE
      FIO=FIO+CT*(F1+F1X)
      FIOX=FIOX+CT*(F1X+F1XX)
      FIOR=FIOR+CT*(F1R+F1XR)
      FIOXX=FIOXX+CT*(F1XX+F2XX)
      FIOXR=FIOXR+CT*(F1XR+F2XR)
      FIORR=FIORR+CT*(F1RR+F2RR)
      FI1=FI1+BT*F4
      FI1X=FI1X+BT*F4X
      FI1R=FI1R+BT*F4R
      IF(KL.EQ.2) RETURN
    3 XIOX=XIOX+C1T*(F1X+F1XX)+C3*F2XX
      XIOR=XIOR+C1T*(F1R+F1XR)+C3*F2XR
      RETURN
      END

      SUBROUTINE NEWT
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/DISC/R1,PI,I,JH,J,KL
      COMMON/WAVE/CABL,CNBL,CMBL,CAW,CNW,CMW
      COMMON/CVP/CXT(240),CNT(240),CMT(240),CPV(21),JA,JB,KF
      COMMON/GEO2/NFL,NN,IPRINT,MAL,MAX,IPR
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BETA
      COMMON/NNI/NTT(11),NP5,JZT
      COMMON/GEO3/VOVS,AL,YINT,F,RR,RREF,AREF,DLN
      PLPI=(1.2D0*VOVS**2)**3.5D0*(6.D0/(7.D0*VOVS**2-1.D0))**2.5
      IF(NFL.EQ.1)GO TO 2
      CPO=0.999D0*(PLPI-1.0D0)/(0.7D0*VOVS**2)
      IF(IPRINT.NE.1)GO TO 19
      WRITE(2,6)CPO
   6  FORMAT(1X,45HKO|fficiEHT DABlEHiq Dlq plOCKOgO zATYplEHiq=,F10.5)
  19  CA=CPO*(RR/RREF)**2
      CABL=CA
      CNBL=0.D0
      CMBL=0.D0
      IF(JZT.EQ.0) RETURN
      GO TO 18
   2  CPO=(PLPI-1.D0)/(0.7D0*VOVS**2)
      IF(IPRINT.NE.1)GO TO 18
      PRINT 8,CPO
   8  FORMAT(1X,25HKO|fficiEHT dABlEHiq dlq ,24HCfEPi~ECKOgO zATYplEHiq
     *,F10.5)
   18 AR=AL
      IF(AR.EQ.0.D0) AR=1.0D-7
      DF=PI/(KF-1.)
      CSA=DCOS(AR)
      SNA=DSIN(AR)
      TNA=SNA/CSA
      I1=KF/2
      DO 3 I=JA,JB
      TNT=RBP(I)
      TET=DATAN(TNT)
      SNT=DSIN(TET)
      CST=DCOS(TET)
      SNFU=TNT/TNA
      P1=CSA*SNT
      P2=SNA*CST
      DO 1 J=1,KF
      SNF=DSIN((I1+1-J)*DF)
      CPV(J)=CPO*(P1-P2*SNF)**2
      IF(SNF.GT.SNFU) CPV(J)=0.D0
  1   END DO
      CALL POPIN
 3    END DO
      RETURN
      END

      SUBROUTINE CSV
      IMPLICIT REAL*8(A-H,O-Z)
      character *12 tx(7),sc*1,sim*78,nos(6)*14
C      real*8 RES(12)
      COMMON/TV/SIG,RXX
      COMMON/LENG/BL,ANL,ALA
      COMMON/IN/ISIG
      COMMON/BASE/CAB,CNB,CMB
      COMMON/BAND/CAP,CNP,CMP,HB
      COMMON/CVP/CXT(240),CNT(240),CMT(240),CPV(21),JA,JB,KF
      COMMON/DISC/R1,PI,I9,JH1,J9,KL
      COMMON/WAVE/CABL,CNBL,CMBL,CAW,CNW,CMW
      COMMON/TAIL1/CXO,CYO,CMO
      COMMON/ICOU/VOLN,SOBS,RJA1,RJA2,ICOUNT,NGOL,NHBS
      COMMON/GEO2/NFL,NN,IPRINT,MAL,MAX,IPR
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BETA
      COMMON/RX/XR(20,6),G(20),GCH,DM,N,N1(20),IX,I1
      COMMON/NNI/NTT(11),NP5,JZT
      COMMON/GEO3/VOVS,AL,YINT,F,RR,RREF,AREF,DLN
      COMMON/VOL/CAF,CNF,CMF,CMX,DIA,RN,AP,XP
      COMMON/PREOBR/PREB(10),RAB1,RAB2,IPE,NPR,NUPR
      COMMON/INPUT_DATA/AINF,RHOINF,AMUINF,CTS,DL,HMAX,DMAX,HUAT,DUAT,
     <DPR,NG,NH,NK
      DIMENSION RAB1(10),RAB2(10),IPN(7),CD(60),AAM(60)
      DIMENSION DCX(60),DCY(60),DXCD(60),DCMX(60),CDON(60),
     <DCML2(60),DCMX2(60)
      DIMENSION AM(50),ETA(44),ALOD(44),AMC(29),CDC(29),rx(60,7)
      data tx/'''  M(1-N3)=''','''CXЭ(1-N3)=''','''CYA(1-N3)=''',
     <''' MX(1-N3)=''','''MZA(1-N3)=''','''MXO(1-N3)=''',
     <'''MZO(1-N3)='''/,(rx(i,4),i=1,60)/60*0.0d0/
      DATA AMC/0.,0.05,0.1,.15,0.2,.25,0.3,.35,0.4,.45,0.5,.55,0.6,.65,0
     *.7,.75,0.8,.85,0.9,.95,1.,1.05,1.1,1.15,1.2,1.25,1.3,1.35,1.4/
      DATA CDC/1.2,1.2,1.2,1.2,1.2,1.2,1.2,
     *1.22,1.25,1.29,1.35,1.45,1.55,1.66,1.73,1.78,1.81,
     *1.83,1.82,1.81,1.8,1.77,1.75,1.72,1.68,1.65,1.61,1.58,1.53/
      DATA ALOD/1.,1.5,2.,2.5,3.0,3.5,4.,4.5,5.,5.5,6.,6.5,7.,7.5,8.,8.5
     *,9.,9.5,10.,10.5,11.0,11.5,12.,12.5,13.,13.5,14.,14.5,15.,15.5,16.
     *,16.5,17.0,17.5,18.,18.5,19.,19.5,20.,21.,22.,23.,24.,25./
      DATA ETA/0.53,0.554,0.57,0.582,0.593,0.603,0.613,0.62,0.627,0.633,
     *0.64,0.647,0.653,0.658,0.664,0.669,0.674,0.678,0.683,0.688,0.692,0
     *.696,0.7,0.704,0.708,0.712,0.716,0.72,0.724,0.728,0.732,0.736,0.74
     *,0.744,0.748,0.753,0.757,0.761,0.765,.744,.782,.79,.798,.806/
      data jj/11/,nos/'(цилиндр)     ','(конус)       ',
     <'(оживало обр.)','(оживало прм.)','(степень)     ',
     <'(парабола)    '/
      OPEN(UNIT=1,FILE='InPut.DAT',STATUS='OLD')
      OPEN(UNIT=2,FILE='Out.DAT')
 106  FORMAT(1X,9HИзделие N,I2,5X,7HОбраз N,I2,5X,9HВариант N,I2,5X,3
     *HAl=,F9.4,5X,2HD=,F6.4)
 107  FORMAT(' Mo=',F7.3,2X,'dM =',F7.3,2X,'al =',F7.3,2X,'dal=',F
     *7.3,2X,'Yint =',F7.3)
 1000 FORMAT(6E9.5)
 1001 FORMAT(15x,'Геометрические характеристики :'/(I6,3X,4f8.4,2f8.4))
 1002 FORMAT(1X,4HAnl=F8.5,2X,4HAla=F8.5,2X,3HBl=F8.5,2X,4HDln=F8.5)
 2000 FORMAT(1X,3HNг=,I2,2X,3HNн=,I2,2X,3HNк=,I2,2X,4HNFL=,I1,2X,
     *7HIPrint=,I1,2X,4HMal=,I2,2X,
     *4HMax=,I2,2X,4HIpr=,I2,2X,3HC2=,F6.4,2X,
     *2Hf=,F5.3,2X,3HRr=,F8.6)
 1005 FORMAT(10F7.4)
      sim(72:78)='      '
C      write(*,'(1x, "Начинается расчет аэродинамики по КОНТУРу.")')
C      write(*,'(1x,a15)') 'Показать? (y/n)'
C      read(*,'(a1)') sc
      SC='y'
C      RJA1=0.
C      RJA2=0.
C      RXX=0.
C      AP=0.
C      DO 44 I=1,10
C      DO 45 J=1,6
C      XR(I,J)=0.
C  45  END DO
C  44  END DO
C      DO 55 I=1,240
C      CXT(I)=0.
C      CNT(I)=0.
C      CMT(I)=0.
C      XB(I)=0.
C      RB(I)=0.
C      RBP(I)=0.
C  55  END DO
C
C      Переменная MVAR нужна была для расчета нескольких форм снарядов
C      Судя по оператору rewind 1 это не работало (вообще)
C      Каждый раз считалась одна и та же форма! //Y.Pavlov
C
C      READ(1,*) MVAR
C      RREF=0.5
c      PI=3.1415926536
C      AREF=PI*RREF**2
C      DO 15 NP =1,MVAR
      NP=1
      NPR=NP
C      READ(1,*)
C      READ(1,*)
C      if(sc.ne.'n') then
C         rewind 1
C         read(1,*)
C         read(1,'(a72,7x)') sim
C         write(2,*) sim
C         sim(48:78)='(Вх. данные из файла InPuT.dat)'
C         write(*,*) sim
C      end if
      NGOL=NG+1
      NHBS=NH+1
      N=NK+1
      IPR=0
      IPP=0
      IPM=0
      INM=0
      DATA IPN/7*0/
C      READ(1,*)
C      if(sc.ne.'n') then
C         rewind 1
C         read(1,*)
C         read(1,*)
C         read(1,'(a72,7x)') sim
C         write(*,*) sim
C         write(2,*) sim
C      end if
      IPP=IPP+1
      IPM=IPM+1
      INM=INM+1
C      READ(1,*) YINT,DIA,HB,AINF,RHOINF,AMUINF,C2,F,CTS,DL
C      READ(1,*)
C      if(sc.ne.'n') then
C         rewind 1
C         read(1,*)
C         read(1,*)
C         read(1,*)
C         read(1,'(a72,7x)') sim
C         write(*,*) sim
C         write(2,*) sim
C      end if
C      open(3,file='cons.dat')
C      write(3,4) DIA,DL
C    4 format(1x,'''DM='' ',f6.4,3x,'''DL='' ',f7.4)
C      READ(1,*) ((XR(I,J),J=1,6),I=2,N)
C      READ(1,*) HMAX,DMAX,HUAT,DUAT,DPR
      dlina=xr(n,2)+YINT
      IF(XR(2,3).LE.1.0D-3) XR(2,3)=0.
      IPR=IPR+1
      DO 15 NIP=1,IPR
      NPR=NIP
      DM=DIA
      NUPR=0
      I1=21
      IF(N1(N).NE.2) GO TO 6
      SLOPE=(XR(N,4)-XR(N,3))/(XR(N,2)-XR(N,1))
      IF(SLOPE.LT.-10.*3.1415926/180.) SLOPE=-.1584
cc
      XR(N,4)=XR(N,3)+(XR(N,2)-XR(N,1))*SLOPE
    6 CONTINUE
      if(sc.ne.'n') then
         do 999 I=2,N
         kkk=N1(I)
         WRITE(sim,'(I6,3x,4f8.4,2f8.4,4x,a14)')
     <   N1(I),(XR(I,J),J=1,6),nos(kkk)
         WRITE(*,*) sim
 999  continue

      end if
      WRITE(2,1001) (N1(I),(XR(I,J),J=1,6),I=2,N)
C      if(sc.ne.'n') then
C         rewind 1
C         do 66 I=2,N+4
C         read(1,*)
C   66    continue
C         read(1,'(a72,7x)') sim
C         WRITE(*,*) sim
C         write(2,*) sim
C      end if
      CXO=0.
      CYO=0.
      CMO=0.
      D4=1.
      IF(IX.EQ.1) D4=DM
      YINT=YINT/D4
      IF(NFL.NE.1) YINT=0.
      DO I=1,N
      PREB(I)=0.
      RAB1(I)=0.
      DO J=1,5
      XR(I,J)=XR(I,J)/D4
      END DO
      END DO
      RR=XR(2,3)
      IX=0
      IF(NIP.EQ.1) DPR=DPR*(XR(INM,2)-XR(INM,1))
      write(2,'(15x,''Ct='',f6.4)') CTS
      ALA=XR(NHBS,2)-XR(NGOL,2)
      BL=XR(N,2)-XR(NHBS,2)
      ANL=XR(NGOL,2)-XR(1,2)+YINT
      DLN=ANL+ALA+BL

      WRITE(2,1002) ANL,ALA,BL,DLN
      WRITE(2,2000) NG,NH,NK,NFL,IPRINT,MAL,MAX,IPR,C2,F,RR
      DO 27 MM=1,MAL
      LSG=0
      LPR=0
      AL=(MM-1)*DUAT+HUAT
      IF(AL.EQ.0.) AL=0.1
      I=NIP-1
      WRITE(2,106) NP,I,MM,AL,DIA
      AL=AL/57.29578D0
      VOVS=HMAX
C
C     Main cycle!!!
C      
C      CALL CSVSTEP(3.1D0, DLN, AL, dlina, RES)
      DO 1 J=1,MAX
      RN=VOVS*AINF*RHOINF/AMUINF
      RE=DM*DLN*RN
      PAL=0.2D0
      SIG=0.046D0*(1.D0+0.0092D0*VOVS**2)**0.88D0/RE**PAL
C      WRITE(*, '(''SIG='',F12.8)') SIG
      IF(ISIG.EQ.0) SIG=0.D0
      IF(LPR.EQ.0) CALL GEOM
      IF(J.GT.1) GO TO 11
      if(sc.eq.'n') WRITE(*,'(1x,''Maxи: '')')
      write(2,'(/1x,''MAX'',3x,''TPEH'',3x,''DON'',4x,''VOLN'',3x,
     <''POIS'',4x,''CN'',5x,''CY'',5x,''XCD'',4x,''CX'',4x,''CYAL'',
     <4x,''MZA'',3x,''-MXWX'',3x,''MZWZ'')')
   11 CALL SKBARB
      IF(VOVS.LE.1.001D0) GO TO 62
      IF(VOVS.GT.1.26D0) GO TO 60
      VOV=VOVS
      IF(LSG.EQ.1) GO TO 61
      VOVS=1.D0
      CALL GEOM
      CALL TRANS
      CALL NORMFO
      Q1=1.D0
      P1A=CAW
      P1N=CNW
      P1M=CMW
      VOVS=1.27D0
      CALL GEOM
      CALL HYBRID
      Q2=1.27D0
      P2A=CAW
      P2N=CNW
      P2M=CMW
      VOVS=1.47D0
      CALL GEOM
      CALL HYBRID
      Q3=1.47D0
      P3A=CAW
      P3N=CNW
      P3M=CMW
      LSG=1
   61 VOVS=VOV
      CALL PROD(P1A,P2A,P3A,Q1,Q2,Q3,VOV,CAW,1)
      CALL PROD(P1N,P2N,P3N,Q1,Q2,Q3,VOV,CNW,1)
      CALL PROD(P1M,P2M,P3M,Q1,Q2,Q3,VOV,CMW,1)
      GO TO 5
C
   60 IF(JZT.EQ.0) GO TO 62
      MEX=1
   67 Q1=2.2D0+0.2D0*(1-MEX)
      VOV=VOVS
      IF(LPR.EQ.1) GOTO 63
      VOVS=Q1
      CALL GEOM
      CALL HYBRID
      P1A=CAW
      P1N=CNW
      P1M=CMW
      Q2=2.7D0+0.2D0*(1-MEX)
      VOVS=Q2
      CALL GEOM
      CALL HYBRID
      MEX=MEX+1
      IF(JZT.EQ.1) GOTO 67
      P2A=CAW
      P2N=CNW
      P2M=CMW
      Q3=13.5D0
      VOVS=Q3
      CALL GEOM
      CALL HYBRID
      P3A=CAW
      LPR=1
      P1N=-P1M/P1N
      P2N=-P2M/P2N
      P3A=P3A*1.02D0
      P3M=P2M+(P2M-P1M)*2.5D0
      P3N=P2N+(P2N-P1N)*(4.9D0+20.D0*AL)
   63 VOVS=VOV
      CALL PROD(P1A,P2A,P3A,Q1,Q2,Q3,VOV,CAW,2)
      CALL PROD(P1M,P2M,P3M,Q1,Q2,Q3,VOV,CMW,2)
      CALL PROD(P1N,P2N,P3N,Q1,Q2,Q3,VOV,C5W,2)
      CNW=-CMW/C5W
      GOTO 5
C
   62 IF(VOVS.LT.1.27D0) CALL NORMFO
      IF(VOVS.GE.0.85D0)GO TO 19
      IST=NTT(NGOL)
      THE1=DATAN(RBP(IST))*57.29578D0
      IF(THE1.GE.10.D0)GO TO 51
      CAW=0.D0
      GO TO 5
  51  CAW=0.012D0*(THE1-10.D0)
      GOTO 5
  19  IF(VOVS.LT.1.26D0)GO TO 2
      CALL HYBRID
      GO TO 5
  2   CALL TRANS
    5 CA=CAF+CAB+CAW+CAP+CXO
      CALL INTERP(ALOD,ETA,DLN,ETA1,44,3)
      AMC1=VOVS*DSIN(AL)
      CALL INTERP(AMC,CDC,AMC1,CDC1,29,3)
      S1=CDC1*ETA1*AP/AREF
      CNV=4.75D0*S1*AL**2.8
      CMV=-5.00D0*S1*XP*AL**2.80/(2.D0*RREF)
      IF(AL.GT.0.0175D0) GO TO 52
      CNV=0.
      CMV=0.
  52  CN=CNF+CNB+CNW+CNP+CNV+CYO*AL
      CM=CMF+CMB+CMW+CMP+CMV+CMO*AL
      CY=CN*DCOS(AL)-CA*DSIN(AL)
      CX=CN*DSIN(AL)+CA*DCOS(AL)
      IF(DABS(AL).LT.0.0001D0) GO TO 3
      CMAL=CM/AL
      XCD=-CM/CN
      CNAL=CN/AL
      CYAL=CY/AL
   3  CONTINUE
c
      ddt = dia/dlina
      xcd = xcd * ddt
      cm = cn * (cts-xcd)
      cmal = cnal * (cts - xcd)
      cmx = cmx * ddt**2
      cmzwz = cnal * (cts - xcd)**2
c
      AM(J)=VOVS
      rx(J,1)=VOVS
      CDON(J)=CAB
      DCX(J)=CX
      rx(J,2)=CX
      DCY(J)=CYAL
      rx(J,3)=CYAL
      DXCD(J)=XCD
      DCMX(J)=CMX
      rx(J,5)=CMAL
      DCMX2(J)=CMX*(-1.0d0)
      rx(J,6)=DCMX2(J)
      DCML2(J)=cmzwz
      rx(J,7)=DCML2(J)
      if(sc.ne.'n') then
         jj=jj+1
         if(jj.gt.10) then
            write(*,'(1x,''_'',''MAX'',2(''_''),''Cxтр'',
     <      2(''_''),''Cxвлн'',2(''_''),''Cxпс'',4(''_''),
     <      ''Cx'',4(''_''),''CYA'',4(''_''),''MZA'',3(''_''),
     <      ''-MXWX'',3(''_''),''MZWZ'',3(''_''),
     <      ''CXDN'',2(''_''),''Cnal'',4(''_''),''XCD'')')
            jj=0
         end if
         XCD1=XCD*dlina
         write(*,'(f5.2,f6.4,f7.4,f6.4,f7.4,f7.4,f7.4,f7.4,f7.4,
     <f7.4,f7.4,F6.3)')
     <   vovs,caf,caw,cap,cx,CYAL,CMAL,CMX,cmzwz,CAB,CNAL,XCD1
      else
         write(*,'(f3.1,'','')') VOVS
      end if
      write(2,'(f4.2,7f7.4,f7.4,f8.4,3f7.4)')
     <vovs,caf,cab,caw,cap,cn,cy,xcd,cx,cyal,cmal,cmx,cmzwz
      VOVS=VOVS+DMAX
      IF(VOVS.GT.0.9D0.AND.VOVS.LT.1.28D0)VOVS=VOVS-DMAX/2.D0
    1 END DO
C
C     End of main cycle!!!
C      
      IF(IPN(1).NE.0) PRINT 1005,(DCX(Ikk),Ikk=1,MAX)
      IF(IPN(2).NE.0) PRINT 1005,(DCY(Ikk),Ikk=1,MAX)
      IF(IPN(3).NE.0) PRINT 1005,(DXCD(Ikk),Ikk=1,MAX)
  27  END DO
      IF(IPN(5).NE.0) PRINT 1005,(AM(Ikk),Ikk=1,MAX)
      IF(IPN(6).NE.0) PRINT 1000,((XR(Ikk,Jkk),Jkk=1,6),Ikk=2,N)
      IF(IPN(4).NE.0) PRINT 1005,(DCMX(Ikk),Ikk=1,MAX)
      IF(IPR.EQ.1) GO TO 15
      CQ1=0.D0
      IF(IPP.EQ.20) CQ1=0.0087D0
      CQ2=0.D0
      IF(IPP.EQ.21) CQ2=0.0175D0
      CQ3=0.D0
      IF(IPP.EQ.22) CQ3=0.1D0
      DO  I=2,N
         IM=NTT(I)
         IF(N1(I).EQ.3) IM=NTT(I-1)+1
         XR(I,6)=XR(I,6)+CQ3
         RAB1(I)=RBP(IM)+CQ1
      END DO
      RAB2(1)=SLOPE+NIP*CQ2
      IF(IPP.EQ.22) GO TO 15
      PREB(IPP)=DPR
      PREB(IPM)=-PREB(IPP)
      CALL PREBR(2)
   15 Continue
      DO 2277 I=1,MAX

 2277 CONTINUE
C      write(3,7) MAX
C    7 format(10x,'''N3='' ',i2)
C      do j=1,7
C      write(3,'(a12,8f7.4:/(12x,8f7.4:))')
C     <tx(j),(rx(i,j),i=1,MAX)
C      end do
      J=0
      EE=0.0001
      DO 200 I=1,39
      IF(DABS(AM(I)-1.0).LE.EE)GO TO 111
      IF(DABS(AM(I)-1.5).LE.EE)GO TO 111
      IF(DABS(AM(I)-2.0).LE.EE)GO TO 111
      IF(DABS(AM(I)-2.5).LE.EE)GO TO 111
      IF(DABS(AM(I)-3.0).LE.EE)GO TO 111
      IF(DABS(AM(I)-3.5).LE.EE)GO TO 111
      IF(DABS(AM(I)-3.8).LE.EE)GO TO 111
      GO TO 222
  111 J=J+1
      AAM(J)=AM(I)
      CD(J)=CDON(I)
  222 CONTINUE
200   CONTINUE
C      write(3,'(10x,'''''''',''N7='','''''''','' 5'',/'''''''',
C     <''AM(1-N7)='','''''''','' '',5f7.2/'''''''',''CXD(1-N7)'',
C     <'''''''','' '',5f7.4,'' /'')') (AAM(i),i=1,5),(CD(i),i=1,5)

      WRITE(2,107) HMAX,DMAX,HUAT,DUAT,YINT
      END

      SUBROUTINE POPIN
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/DISC/R1,PI,I,JH,J,KL
      COMMON/CVP/CXT(240),CNT(240),CMT(240),CPV(21),JA,JB,KF
      COMMON/GEOM1/XB(240),RB(240),RBP(240),C2,BETA
      DF=PI/(KF-1.)
      F1=0.D0
      F2=0.D0
      DO 1 IJ=1,KF
      S=3.D0+(-1.D0)**IJ
      IF(IJ.EQ.1.OR.IJ.EQ.KF) S=1.D0
      S1=S*CPV(IJ)
      F1=F1+S1
      F2=F2+S1*DCOS((IJ-1)*DF)
 1    END DO
      S=RB(I)*DF/3.D0
      CXT(I)=F1*S
      CNT(I)=F2*S
      CMT(I)=F2*(XB(I)+RB(I)*RBP(I))*S
      RETURN
      END

module penetration
    use iso_c_binding
    implicit none
    integer, parameter:: dp=(kind(0.d0))
    real(c_double), parameter:: pi = 3.1415926536883458

    
    type, bind(c) :: material
        real(c_double):: sigma
        real(c_double):: rho
        real(c_double):: C
        real(c_double):: a
        real(c_double):: lambda
    end type material

    type, bind(c) :: hedge
        type(material) :: mat
        real(c_double):: E
        real(c_double):: nu
        real(c_double):: lambda1
        real(c_double):: A
        real(c_double):: gamma
    end type hedge

    type, bind(c) :: kernel
        type(material) :: mat
        real(c_double):: c_zv
        real(c_double):: da
        real(c_double):: la
        real(c_double):: vc
    end type kernel

    type, bind(c) :: pen_prob
        real(c_double):: u_0
        real(c_double):: d
        real(c_double):: r_g
    end type pen_prob

    contains

        subroutine set_hedge_material(ahedge, sigma, rho, a, lambda) bind(c, name="set_hedge_material")
            type(hedge), intent(out):: ahedge
            real(c_double), intent(in), value:: sigma, rho, a, lambda

            type(material):: mat

            mat%sigma = sigma
            mat%rho = rho
            mat%C = 0.5_dp * rho
            mat%a = a
            mat%lambda = lambda

            ahedge%mat = mat

        end subroutine set_hedge_material

        subroutine set_kernel_material(akernel, sigma, rho, a, lambda) bind(c, name="set_kernel_material")
            type(kernel), intent(out):: akernel
            real(c_double), intent(in), value:: sigma, rho, a, lambda

            type(material):: mat

            mat%sigma = sigma
            mat%rho = rho
            mat%C = 0.5_dp * rho
            mat%a = a
            mat%lambda = lambda

            akernel%mat = mat

        end subroutine set_kernel_material

        subroutine init_hedge(ahedge, E, nu, lambda1) bind(c, name="init_hedge")
            type(hedge), intent(out):: ahedge
            real(c_double), intent(in), value:: E, nu, lambda1

            ahedge%E = E
            ahedge%nu = nu
            ahedge%lambda1 = lambda1

        end subroutine init_hedge

        subroutine init_kernel(akernel, c_zv, da, la, vc) bind(c, name="init_kernel")
            type(kernel), intent(out):: akernel
            real(c_double), intent(in), value:: c_zv, da, la, vc

            akernel%c_zv = c_zv
            akernel%da = da
            akernel%la = la
            akernel%vc = vc
            
        end subroutine init_kernel

        subroutine compute_hedge(ahedge, u0)
            type(hedge), intent(out):: ahedge
            real(c_double), intent(in):: u0
            real(c_double):: alpha, gamma, gam0, k_u0, rho_to_rho, A, sigma_h, E_h, a_h, lam_h, A1, A2
            sigma_h = ahedge%mat%sigma
            E_h = ahedge%E
            a_h = ahedge%mat%a
            lam_h = ahedge%mat%lambda

            alpha = sigma_h / (2.0_dp * E_h * ahedge%lambda1)
            gam0 = (E_h / (3.0_dp * (1.0_dp - ahedge%nu) * sigma_h)) ** (1.0_dp / 3)
            k_u0 = (2.0_dp * gam0 ** 2 - gam0 - 1.0_dp) / ((gam0 + 1.0_dp) * (gam0 ** 3 - 1.0_dp))
            rho_to_rho = 1.0_dp - (k_u0 * u0) / (a_h + lam_h * k_u0 * u0)
            gamma = (1 - rho_to_rho * exp(-3.0_dp * alpha)) ** (-1.0_dp / 3)

            A1 = sigma_h * log(gamma)
            A2 = (1.0_dp - ahedge%lambda1) * (1.0_dp - 1.0_dp / gamma ** 3) ** 0.62 * pi ** 2 / 18.0_dp
            A2 = A2 + sigma_h / (2.0_dp * E_h * ahedge%lambda1)
            A2 = A2 * E_h * 2.0_dp / 3.0_dp

            A = 2 * (A1 + A2)

            ahedge%gamma = gamma
            ahedge%A = A

        end subroutine compute_hedge

        real(c_double) function get_u0(ahedge, akernel) result(u_0)
            type(hedge), intent(in):: ahedge
            type(kernel), intent(in):: akernel

            real(c_double):: a_0, b_0, c_0

            a_0 = akernel%mat%lambda - ahedge%mat%lambda * (ahedge%mat%rho / akernel%mat%rho)

            b_0 = 2.0_dp * akernel%mat%lambda * akernel%vc + akernel%mat%a + ahedge%mat%a * (ahedge%mat%rho / akernel%mat%rho)

            c_0 = akernel%mat%a * akernel%vc + akernel%mat%lambda * akernel%vc ** 2

            u_0 = (b_0 - sqrt((b_0 ** 2) - (4.0_dp * a_0 * c_0))) / (2.0_dp * a_0)

        end function get_u0

        real(c_double) function get_rg(ahedge, akernel, u_0) result(r_g)
            type(hedge), intent(in):: ahedge
            type(kernel), intent(in):: akernel

            real(c_double), intent(in):: u_0

            r_g = 0.5_dp * akernel%da
            r_g = r_g * (1.0_dp + sqrt((2.0_dp*akernel%mat%rho*(akernel%vc - u_0) ** 2) / ahedge%A))

        end function get_rg

        real(c_double) function get_d(ahedge, akernel, r_g) result(d)
            type(hedge), intent(in):: ahedge
            type(kernel), intent(in):: akernel

            real(c_double), intent(in):: r_g

            d = ahedge%mat%rho * r_g * ((ahedge%gamma - 1.0_dp) / (ahedge%gamma + 1.0_dp))

        end function get_d

        subroutine penetration_rs(dy, y, prob, akernel, kernel_mat, ahedge, hedge_mat)
            real(c_double), intent(out) :: dy(4)
            real(c_double), intent(in) :: y(4)
            type(pen_prob), intent(in):: prob
            type(kernel), intent(in):: akernel
            type(hedge), intent(in):: ahedge
            type(material), intent(in):: hedge_mat, kernel_mat
            
            real(c_double):: s, factor, d_u, d, dxdt, dldt, dvdt, dudt, u, v, l

            u = y(4)
            v = y(3)
            l = y(2)

            factor = 1.0_dp + (v - u) / akernel%c_zv
            s = 0.5_dp * prob%r_g * (v / u - 1.0_dp) * (1.0_dp - 1.0_dp / ahedge%gamma ** 2)
            d_u = hedge_mat%rho * s
            d = kernel_mat%rho * prob%r_g * ((ahedge%gamma - 1.0_dp) / (ahedge%gamma + 1.0_dp))
            dxdt = u
            dldt = u - v
            dudt = ((kernel_mat%sigma * factor) + (kernel_mat%C * (v - u) ** 2) - ahedge%A - (hedge_mat%C * u ** 2)) / (d + d_u)
            dvdt = -kernel_mat%sigma / (kernel_mat%rho * (l - s)) * factor

            dy(1) = dxdt
            dy(2) = dldt
            dy(3) = dvdt
            dy(4) = dudt

        end subroutine penetration_rs

        subroutine compute_penetration(y_s, prob, akernel, ahedge, tstep, tmax) bind(c, name="compute_penetration")
            real(c_double), intent(inout):: y_s(4)
            real(c_double), intent(in), value:: tstep, tmax
            type(pen_prob), intent(inout):: prob
            type(kernel), intent(inout):: akernel
            type(hedge), intent(inout):: ahedge

            type(material):: hedge_mat, kernel_mat

            real(c_double):: t0, y_s_1(4), dy(4, 4)

            logical:: stop_status


            prob%u_0 = get_u0(ahedge, akernel)
            call compute_hedge(ahedge, prob%u_0)
            prob%r_g = get_rg(ahedge, akernel, prob%u_0)
            prob%d = get_d(ahedge, akernel, prob%r_g)

            hedge_mat = ahedge%mat
            kernel_mat = akernel%mat

            t0 = 0.0_dp

            y_s_1(1) = 0.0_dp
            y_s_1(2) = akernel%la
            y_s_1(3) = akernel%vc
            y_s_1(4) = prob%u_0

            stop_status = .true.

            do while(stop_status)
                y_s = y_s_1
                call penetration_rs(dy(:, 1), y_s, prob, akernel, kernel_mat, ahedge, hedge_mat)
                call penetration_rs(dy(:, 2), y_s + 0.5*tstep*dy(:, 1), prob, akernel, kernel_mat, ahedge, hedge_mat)
                call penetration_rs(dy(:, 3), y_s + 0.5*tstep*dy(:, 2), prob, akernel, kernel_mat, ahedge, hedge_mat)
                call penetration_rs(dy(:, 4), y_s + tstep*dy(:, 3), prob, akernel, kernel_mat, ahedge, hedge_mat)

                t0 = t0 + tstep

                y_s_1 = y_s +  tstep*(dy(:, 1) + 2.0_dp * dy(:, 2) + 2.0_dp * dy(:, 3) + dy(:, 4)) / 6.0_dp

                if (t0 > tmax) then
                    stop_status = .false.
                else
                    stop_status = y_s_1(2) > 0.0_dp
                    stop_status = stop_status .and. (y_s_1(3) > 0.0_dp)
                    stop_status = stop_status .and. (y_s_1(4) > 0.0_dp)
                end if

            end do

        end subroutine compute_penetration

        subroutine dense_compute_penetration(y_s, ntsteps, prob, akernel, ahedge, tstep, tmax) bind(c, name="dense_compute_penetration")
            real(c_double), intent(inout):: y_s(4, ntsteps)
            integer(c_int), intent(inout):: ntsteps
            real(c_double), intent(in), value:: tstep, tmax
            type(pen_prob), intent(inout):: prob
            type(kernel), intent(inout):: akernel
            type(hedge), intent(inout):: ahedge

            type(material):: hedge_mat, kernel_mat

            integer(c_int):: i

            real(c_double):: t0, dy(4, 4)

            logical:: stop_status

            prob%u_0 = get_u0(ahedge, akernel)
            call compute_hedge(ahedge, prob%u_0)
            prob%r_g = get_rg(ahedge, akernel, prob%u_0)
            prob%d = get_d(ahedge, akernel, prob%r_g)


            hedge_mat = ahedge%mat
            kernel_mat = akernel%mat

            t0 = 0.0_dp

            y_s(1, 1) = 0.0_dp
            y_s(2, 1) = akernel%la
            y_s(3, 1) = akernel%vc
            y_s(4, 1) = prob%u_0

            stop_status = .true.
            
            do i=2, ntsteps
                if (.not. stop_status) then
                    ntsteps = i - 1
                    return
                end if
                call penetration_rs(dy(:, 1), y_s(:, i-1), prob, akernel, kernel_mat, ahedge, hedge_mat)
                call penetration_rs(dy(:, 2), y_s(:, i-1) + 0.5*tstep*dy(:, 1), prob, akernel, kernel_mat, ahedge, hedge_mat)
                call penetration_rs(dy(:, 3), y_s(:, i-1) + 0.5*tstep*dy(:, 2), prob, akernel, kernel_mat, ahedge, hedge_mat)
                call penetration_rs(dy(:, 4), y_s(:, i-1) + tstep*dy(:, 3), prob, akernel, kernel_mat, ahedge, hedge_mat)

                t0 = t0 + tstep

                y_s(:, i) = y_s(:, i-1) +  tstep*(dy(:, 1) + 2.0_dp * dy(:, 2) + 2.0_dp * dy(:, 3) + dy(:, 4)) / 6.0_dp

                if (t0 > tmax) then
                    stop_status = .false.
                else
                    stop_status = y_s(2, i) > 0.0_dp
                    stop_status = stop_status .and. (y_s(3, i) > 0.0_dp)
                    stop_status = stop_status .and. (y_s(4, i) > 0.0_dp)
                    stop_status = stop_status .and. (y_s(3, i) - y_s(4, i) > 0.0)
                end if

            end do

        end subroutine dense_compute_penetration

end module penetration

      SUBROUTINE INTERP(TX,TY,X,Y,N,J)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION TX(N),TY(N)
      N1=N-2
      DO 1 I=J,N1
      IF(X.LE.TX(I)) GO TO 2
   1  END DO
      I=N1
   2  CALL INTER5(X,TX(I-2),TX(I-1),TX(I),TX(I+1),TX(I+2),TY(I-2),TY(I-1
     *),TY(I),TY(I+1),TY(I+2),Y)
      RETURN
      END
